﻿if exists ( select * from sysobjects where id=object_id('dbo.A_Personal_NumbersInfo_GetSeparate'))
	Drop procedure dbo.A_Personal_NumbersInfo_GetSeparate
GO


Create Procedure [dbo].[A_Personal_NumbersInfo_GetSeparate]
As
Begin


	-- Информация по отделам и составляющим частям номеров
	
	Declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
	Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
		Select np.Id, np.Prefix, rr.ReactId
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join A_Rules r on na.ExtraId = r.Id
			Inner Join A_RuleRecords rr on rr.RuleId = r.Id
		Where na.NumType = 0 --только стандартные (расчет отделов по входящим в состав элементам)

	Declare @otherdeps nvarchar(200)
	Select @otherdeps = langvalue 
	From A_LangTexts
	Where langkey like 'otherdeps'
	if ( @otherdeps is NULL )
		Set @otherdeps = 'Прочие подразделения'

	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', @otherdeps )


	Declare @cnt int
	Set @cnt = 0

	While ( @@rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--Выгребаем ссылки на номера @cnt - уровня
		Insert Into @temp
			Select t.nid, t.prefix, t.reactid, t1.reactid
			From @t t
				 Inner Join @t t1 on ( t.Reactid = t1.nId ) and ( t1.nId != t.nId ) and ( t1.reactid != t.nId )
			Where t.ReactId != t.Nid
			Group by t.nid, t.prefix, t.reactid, t1.reactid
	
		--Удаляем то что будем менять
		Delete From @t
			From @temp
		Where nid = id and reactid = oldrid

		--вставляем замены
		Insert Into @t ( nid, prefix, reactid )
			Select id, prefix, newrid From @temp

		--чистим времянку
		Delete From @temp	
	end

	-- удаляем остатки ссылок на номера
	Delete From @t
		From A_NumberPlan np
	Where reactid = np.Id
	
	Declare @eid uniqueidentifier
	Set @eid = '00000000-0000-0000-0000-000000000000'
	
	-- Инфу возвращаем
	Select nId, Prefix, ReactId, GroupId, GroupName, ReactType
	From
	(
		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as ReactType
		From @t t
			Inner Join A_Users u on t.ReactId = u.Id
			Inner Join @groups g on u.ParentGroupId = g.GroupId
	
		Union all

		Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as ReactType
		From @t t
			Inner Join A_View_ServerIntLinesAll l on t.ReactId = l.Id
			Inner Join @groups g on l.ParentGroupId = g.GroupId

		Union all

		-- Отдельно все кроме стандартных
		Select np.Id, np.Prefix, @eid, g.GroupId, g.GroupName, 2
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join @groups g on na.ExtraId = g.GroupId
		Where na.NumType != 0
	)a
	Order By Prefix
End
GO


if exists ( select * from sysobjects where id=object_id('dbo.A_Personal_GetNumbersDepartmentInfo'))
	Drop procedure dbo.A_Personal_GetNumbersDepartmentInfo
GO


Create Procedure [dbo].[A_Personal_GetNumbersDepartmentInfo]
As
Begin
	-- Возвращает таблицу соответствий внутренних номеров отделам

	Declare @otherdeps nvarchar(200)
	Select @otherdeps = langvalue 
	From A_LangTexts
	Where langkey like 'otherdeps'
	if ( @otherdeps is NULL )
		Set @otherdeps = 'Прочие подразделения'


	Declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
	Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
		Select np.Id, np.Prefix, rr.ReactId
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join A_Rules r on na.ExtraId = r.Id
			Inner Join A_RuleRecords rr on rr.RuleId = r.Id
		Where na.NumType != 2 --все кроме быстрых (у них отдельно отделы проставлены)


	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', @otherdeps )

	
	Declare @cnt int
	Set @cnt = 0

	While ( @@rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--Выгребаем ссылки на номера @cnt - уровня
		Insert Into @temp
			Select t.nid, t.prefix, t.reactid, t1.reactid
			From @t t
				Inner Join @t t1 on ( t.Reactid = t1.nId ) and ( t1.nId != t.nId ) and ( t1.reactid != t.nId )
			Where t.ReactId != t.Nid
			Group by t.nid, t.prefix, t.reactid, t1.reactid
	
		--Удаляем то что будем менять
		Delete 	From @t
			From @temp
		Where nid = id and reactid = oldrid

		--вставляем замены
		Insert Into @t ( nid, prefix, reactid )
			Select id, prefix, newrid From @temp

		--чистим времянку
		Delete From @temp	
	end

	-- Удаляем остатки ссылок на номера
	Delete From @t
		From A_NumberPlan np
	Where reactid = np.Id

	-- Обновляем инфу по группам
	Declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert Into @output
		Select nid, Prefix, groupid, groupname From 
		(
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner Join A_Users u on t.ReactId = u.Id
				Inner Join @groups g on u.ParentGroupId = g.GroupId
			Union all

			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner join A_View_ServerIntLinesAll l on t.ReactId = l.Id
				Inner Join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
		) a
		Group By Prefix, GroupId, nid, groupname


	-- Прочие подразделения для тех, у кого много разных отделов внутри значится
	Declare @og table ( id uniqueidentifier, cnt int )
	Insert into @og
		Select * From
		(
			Select nid, count ( * ) as cnt
			From @output
			Group By nid
		)a
	
	Update @output 
	Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = @otherdeps
	From @output o, @og og
	Where o.nid = og.id and og.cnt > 1


	-- Отдельно быстрые номера
	Insert into @output
		Select np.Id, np.Prefix, g.GroupId, g.GroupName
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join @groups g on na.ExtraId = g.GroupId
		Where na.NumType = 2


	-- Итог достаем
	Select nid, prefix, groupid, groupname 
	From @output
	Group By nid, prefix, groupid, groupname

End
GO