﻿If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnId' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnId] int default 0
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnString' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnString] nvarchar(1000) default ''
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnString' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnString] nvarchar(1000) default ''
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbConnMode' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbConnMode] int default 1
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DbProviderName' )
	Alter Table oktell_settings.dbo.A_TaskManager_Lists
	Add [DbProviderName] nvarchar(100) default ''
GO


If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_TaskManager_Lists' ))
    begin
      Update oktell_settings.dbo.A_TaskManager_Lists
      Set DbConnId = 0
      Where DbConnId is null

      Update oktell_settings.dbo.A_TaskManager_Lists
      Set DbConnString = ''
      Where DbConnString is null

      Update oktell_settings.dbo.A_TaskManager_Lists
      Set DbConnMode = 1
      Where DbConnMode is null

      Update oktell_settings.dbo.A_TaskManager_Lists
      Set DbProviderName = ''
      Where DbProviderName is null
    end
    

if Exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_Lists' ))
	Drop view dbo.A_TaskManager_Lists
GO

Create View dbo.A_TaskManager_Lists 
as
 	Select * 
	From oktell_settings.dbo.A_TaskManager_Lists
GO



if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_Save' ))
	Drop procedure dbo.A_TaskManager_List_Save
GO

Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@getviewedfromtable bit = 1,
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 ),
	@dbconnid int = 0,
	@dbconnstring nvarchar(1000) = '',
	@dbconnmode int = 0,
	@dbprovidername nvarchar(100) = ''
as
begin
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	-- если это локальная таблица, и изменено ее имя
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		Name 			= @name,
		Description 		= @description,
		ProjectId 		= @idproject,
		Type 			= @type,
		Query 			= @query,
		JoinedTable 		= @joinedtable,
		GetViewedFromTable	= @getviewedfromtable,
		ColumnId 		= @columnid,
		ColumnsPhone 		= @columnsphone,
		ColumnName 		= @columnname,
		ColumnsViewed 		= @columnsviewed,
		ColumnsViewedDescription = @columnsvieweddescription,
		ColumnsSqlType 		= @columnssqltype,
		ColumnsSqlTypeSize 	= @columnssqltypesize,
		DbConnId		= @dbconnid,
		DbConnString		= @dbconnstring,
		DbConnMode		= @dbconnmode,
		DbProviderName		= @dbprovidername
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, GetViewedFromTable, ColumnId, ColumnsPhone, ColumnName, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize, DbConnId, DbConnString, DbConnMode, DbProviderName )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @getviewedfromtable, @columnid, @columnsphone, @columnname, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize, @dbconnid, @dbconnstring, @dbconnmode, @dbprovidername )
end
GO


if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_GetInfo' ))
	Drop procedure dbo.A_TaskManager_List_GetInfo
GO

Create procedure [dbo].[A_TaskManager_List_GetInfo]
	@id uniqueidentifier
as
begin

	Select Id, Name, Description, ProjectId, Type, 
		Query, JoinedTable, ColumnId, ColumnsPhone, 
		ColumnName, ColumnsViewed, ColumnsViewedDescription,
		ColumnsSqlType, ColumnsSqlTypeSize,
		GetViewedFromTable,
		DbConnId, DbConnString, DbConnMode, DbProviderName
	From A_TaskManager_Lists
	Where Id = @id or ProjectId = @id
	Order by Name
end
GO



if exists ( select * from sysobjects where id=object_id ( 'dbo.A_TaskManager_List_JoinedTable_GetParams' ))
	Drop procedure dbo.A_TaskManager_List_JoinedTable_GetParams
GO

Create procedure [dbo].[A_TaskManager_List_JoinedTable_GetParams]
	@idlist 	uniqueidentifier
as
begin
	
	Select JoinedTable, Query, ColumnId, ColumnsPhone, DbConnId, DbConnString, DbConnMode, DbProviderName 
	FROM A_TaskManager_Lists
	Where Id = @idlist
end
GO
