﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Clear' ))
	Drop procedure dbo.A_DynamicConfig_Clear
GO

Create Procedure [dbo].[A_DynamicConfig_Clear] 
as
begin
	Delete FROM A_ServerExtLines Where IsDynamicConfig = 1
	Delete FROM A_ServerGates Where IsDynamicConfig = 1
	Delete FROM A_ServerStreams Where IsDynamicConfig = 1
	Delete FROM A_CallRoutes Where IsDynamicConfig = 1

	Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_RemoveTails' ))
	Drop procedure dbo.A_DB_RemoveTails
GO

Create Procedure [dbo].[A_DB_RemoveTails] 
as
begin

-- Отрубание глюков после изменений в БД. Лишние ссылки, пустые элементы и т.д.

		-----------------------------------------------------
		-- динамические объекты карты сети ------------------
		-----------------------------------------------------
		exec A_DynamicConfig_Clear

		-----------------------------------------------------
		-- общие возможные глюки ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		Delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		Delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )

		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WORKPLACES Union 
			Select [id] From A_Users union
			Select [id] From A_ExtNumbers union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		--записи правил, где пользователь или линия несуществующие
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		--записи правил, где поток несуществующий
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		Delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		Delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		Delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users u inner join A_UserParams up on u.Id = up.IdUser Where up.IsOperator = 1 Union Select Id From C_Groups )
		Delete From A_TaskManager_TaskProperties where not IdTask in ( Select id From A_TaskManager_Tasks )

		-----------------------------------------------------
		-- сетевые адреса рабочих мест = адресу сервера - заменяем брехней 
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = 'Ошибка в адресе' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null в 0 в ID юзеров по умолчанию ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		-- в 0 несуществующих юзеров по умолчанию -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		-- двоение юзеров по умолчанию в ссылках по линиям --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		-- удаляем несуществующие значения ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id From C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id From @uidt)
			or not UserB in (Select id From @uidt)

		-----------------------------------------------------
		-- Редиректы на удаленных юзеров --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		-- Пустые группы, номера, несвязанные правила -------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		exec A_Admin_Number_SiftByActions
		
		exec A_Admin_Rule_SiftByNumbers
		
		-----------------------------------------------------
		-- неиспользуемые плагин-модули ---------------------
		-----------------------------------------------------
		Delete From A_PluginMenu_User
		Where not exists ( Select Id From A_Users u Where u.Id = A_PluginMenu_User.IdUser )

		-----------------------------------------------------
		-- канонические адреса ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address

end
GO
