﻿if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_CallCenter_Info_GetOperatorTasks' ))
	Drop procedure dbo.W_CallCenter_Info_GetOperatorTasks
GO

Create procedure [dbo].[W_CallCenter_Info_GetOperatorTasks]
	@operator uniqueidentifier							-- id оператора

as
begin

	declare	@table table
	(
		IdOperator uniqueidentifier,
		IdTask uniqueidentifier,
		TaskName nvarchar(500) Collate Database_Default,
		TaskStatus int,
		IdProject uniqueidentifier,
		ProjectName nvarchar(500) Collate Database_Default
	)

	insert into @table
		select	o.OperatorId,
				t.Id,
				t.Name,
				t.Active,
				p.Id,
				p.Name
		from	[Oktell_settings].[dbo].[A_TaskManager_Operators] o
					inner join [Oktell_settings].[dbo].[A_TaskManager_Tasks] t
					on o.TaskId = t.Id
						inner join [Oktell_settings].[dbo].[A_TaskManager_Tasks] tp
						on t.Id = tp.Id
							inner join [Oktell_settings].[dbo].[A_TaskManager_Projects] p
							on tp.IdProject = p.Id
		where	o.OperatorId = @operator


	select * from @table

end

GO