﻿
-----------------------------------------------------------------------
-- Удаление проставившихся таблиц абонентов в авто-задачах, признак - отсутствие привязки к проекту
Delete 
From A_Policy_Objects	
Where ([type] = 107) 
	and not exists (Select id From A_TaskManager_Lists l Where (l.ProjectId != '00000000-0000-0000-0000-000000000000') and (l.Id = A_Policy_Objects.Id))
	
Delete
From A_Policy_Objects
Where ([type] = 102)
	and not exists (Select id From A_SmsTaskManager_Tasks t Where t.Id = A_Policy_Objects.Id)
	and not exists (Select id From A_TaskManager_Tasks t Where (t.Id = A_Policy_Objects.Id) and (t.CreationType != 4))

Delete 
From A_Policy_SubjectPrivileges
WHere not exists ( Select Id From A_Policy_Objects o where o.Id = A_Policy_SubjectPrivileges.idObject )
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_Save' ))
	Drop procedure dbo.[A_TaskManager_List_Save]
GO
	
Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@getviewedfromtable bit = 1,
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnoperator nvarchar ( 100 ) = '',
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 ),
	@dbconnid int = 0,
	@dbconnstring nvarchar(1000) = '',
	@dbconnmode int = 0,
	@dbprovidername nvarchar(100) = '',
	@iduser uniqueidentifier = NULL
as
begin
	-- Сохраняет данные о таблице абонентов
	
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	-- если это локальная таблица, и изменено ее имя
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		[Name]					= @name,
		[Description]			= @description,
		[ProjectId]				= @idproject,
		[Type]					= @type,
		[Query]					= @query,
		[JoinedTable]			= @joinedtable,
		[GetViewedFromTable]	= @getviewedfromtable,
		[ColumnId] 				= @columnid,
		[ColumnsPhone] 			= @columnsphone,
		[ColumnName] 			= @columnname,
		[ColumnOperator] 		= @columnoperator,
		[ColumnsViewed] 		= @columnsviewed,
		[ColumnsViewedDescription] = @columnsvieweddescription,
		[ColumnsSqlType] 		= @columnssqltype,
		[ColumnsSqlTypeSize] 	= @columnssqltypesize,
		[DbConnId]				= @dbconnid,
		[DbConnString]			= @dbconnstring,
		[DbConnMode]			= @dbconnmode,
		[DbProviderName]		= @dbprovidername
	Where Id = @id

	if ( @@rowcount = 0 ) begin

		-- Добавляется новый		
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, GetViewedFromTable, ColumnId, ColumnsPhone, ColumnName, ColumnOperator, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize, DbConnId, DbConnString, DbConnMode, DbProviderName )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @getviewedfromtable, @columnid, @columnsphone, @columnname, @columnoperator, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize, @dbconnid, @dbconnstring, @dbconnmode, @dbprovidername )
		
	end
		
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии
	   только если это не авто список для задач из IVR (признак - отсутствие привязки к проекту)
	   */
	if ( @idproject != '00000000-0000-0000-0000-000000000000' )
		exec A_Policy_Objects_Save
			@idObject = @id,
			@type = 107,
			@name = @name,
			@idParentProject = @idproject,
			@actionUserId = @iduser
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_Delete' ))
	Drop procedure dbo.[A_TaskManager_List_Delete]
GO
			
Create procedure [dbo].[A_TaskManager_List_Delete]
	@id uniqueidentifier,
	@droptable bit = 1,
	@iduser uniqueidentifier = NULL
as
begin

	-- Задачи обновляем
	Update A_TaskManager_Tasks
	Set ListId = '00000000-0000-0000-0000-000000000000'
	Where ListId = @id

	-- Запоминаем тип и закрепленную таблицу
	Declare @type int, @jt nvarchar ( 100 ), @idproject uniqueidentifier
	
	Select @type = t.[Type], 
		   @jt = t.[JoinedTable],
		   @idproject = t.[ProjectId]
	From A_TaskManager_Lists t
	Where t.[id] = @id
	
	-- Из таблиц
	Delete 
	From A_TaskManager_Lists
	Where Id = @id

	-- Локальную таблицу
	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt
	if ( @type in ( 1, 5, 6 ) ) and ( @droptable = 1 ) begin
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql
	end		
	
	
	-- Из таблиц политики прав доступа к объектам
	--   только если это не авто список для задач из IVR (признак - отсутствие привязки к проекту)
	if ( @idproject != '00000000-0000-0000-0000-000000000000' )
		exec A_Policy_Objects_Remove @id
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Filter' ))
	Drop procedure dbo.A_Policy_Filter
GO

Create procedure dbo.A_Policy_Filter
as 
begin
	-- Очищает остатки по удаленным объектам и субъектам из таблиц правовой политики
	
	-- Объекты
	Delete
	From dbo.A_Policy_Objects
	Where (([type] = 101) -- Projects
			and not exists ( Select o.[Id] From A_TaskManager_Projects o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 102) -- Tasks
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_Objects.[id] )
			and not exists ( Select o.[Id] From A_SmsTaskManager_Tasks o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 103) -- Reports
			and not exists ( Select o.[Id] From A_CallCenter_Reports o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 104) -- Indicators
			and not exists ( Select o.[Id] From A_CallCenter_Indicators o Where o.[Id] = A_Policy_Objects.[id] ))
		--or (([type] = 105) -- Dashboards		
		--	and not exists ( Select o.[Id] From WO_Dashboards o Where o.[Id] = A_Policy_Objects.[id] ))
		--or (([type] = 106) -- Scripts
		--	and not exists ( Select o.[Id] From A_Scripts o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 107) -- CallLists
			and not exists ( Select o.[Id] From A_TaskManager_Lists o Where o.[Id] = A_Policy_Objects.[id] ))
		
		
	-- Привилегии
	Delete
	From dbo.A_Policy_SubjectPrivileges
	Where not exists ( Select o.[Id] From A_Policy_Privileges o Where o.[id] = A_Policy_SubjectPrivileges.[idPrivilege] )
		
		
	-- Субъекты обычные
	Delete
	From dbo.A_Policy_SubjectPrivileges
	Where (([subjType] = 1) -- Users
			and not exists ( Select o.[Id] From A_Users o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] = 2) -- Groups
			and not exists ( Select o.[Id] From A_Groups o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] = 3) -- Roles
			and not exists ( Select o.[Id] From A_UserRoles_Roles o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))					
		or (([subjType] in (5, 8)) -- TaskOperators, TaskSupervisors
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] in (6, 9, 10)) -- ProjectOperators, ProjectSupervisors, ProjectOwners
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] in (12, 13))-- CurrentProject Operators, Supervisors
			and not exists ( Select o.[Id] From A_TaskManager_Projects o Where o.[Id] = A_Policy_SubjectPrivileges.[subjExtraId] ))
			
			
	-- Субъекты в замыкании
	Delete
	From dbo.A_Policy_SubjectPrivileges
	Where ([subjType] = 101)
		and (( not exists ( Select o.[Id] From A_Policy_Objects o Where o.[id] = A_Policy_SubjectPrivileges.[idSubject] ))
			or ( not exists ( Select o.[Id] From A_Policy_Privileges o Where o.[id] = A_Policy_SubjectPrivileges.[subjExtraId] )))
			
	-- Кэш
	Delete
	From dbo.A_Policy_SubjectGroupCache
	Where not exists ( Select o.Id From A_Users o Where o.[Id] = A_Policy_SubjectGroupCache.[idUser] )
		or (([subjType] = 1) -- Users
			and not exists ( Select o.[Id] From A_Users o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] = 2) 
			and not exists ( Select o.Id From A_Groups o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] = 3) 
			and not exists ( Select o.Id From A_UserRoles_Roles o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] in (5, 8)) -- TaskOperators, TaskSupervisors
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] in (6, 9, 10)) -- ProjectOperators, ProjectSupervisors, ProjectOwners
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] in (12, 13))-- CurrentProject Operators, Supervisors
			and not exists ( Select o.[Id] From A_TaskManager_Projects o Where o.[Id] = A_Policy_SubjectGroupCache.[subjExtraId] ))
					
					
	-- Сопоставление с объектами в таблице типов
	Delete 
	From A_Policy_SubjectPrivileges
	WHere not exists ( Select Id From A_Policy_Objects o where o.Id = A_Policy_SubjectPrivileges.idObject )	
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_DB_RemoveTails' ))
	Drop procedure dbo.[A_DB_RemoveTails]
GO

Create Procedure [dbo].[A_DB_RemoveTails] 
as
begin

-- Отрубание глюков после изменений в БД. Лишние ссылки, пустые элементы и т.д.

		-----------------------------------------------------
		-- преобразования на стыке версий -------------------
		-----------------------------------------------------

		Update dbo.A_ServerExtLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerGSMLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerIntLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerSipLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerUSBLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerVirtualLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		-----------------------------------------------------
		-- общие возможные глюки ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		Delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		Delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )

		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WORKPLACES Union 
			Select [id] From A_Users union
			Select [id] From A_ExtNumbers union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		--записи правил, где пользователь или линия несуществующие
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		--записи правил, где поток несуществующий
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		Delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		Delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		Delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users u inner join A_UserParams up on u.Id = up.IdUser Where up.IsOperator = 1 Union Select Id From C_Groups )
		Delete From A_TaskManager_TaskProperties where not IdTask in ( Select id From A_TaskManager_Tasks )
		Delete From A_TaskManager_Lists Where (ProjectId = '00000000-0000-0000-0000-000000000000') and not exists ( Select Id From A_TaskManager_Tasks t where t.ListId = A_TaskManager_Lists.Id )
		Delete From A_TaskManager_Tasks Where (IdProject = '00000000-0000-0000-0000-000000000000') and not exists ( Select Id From A_TaskManager_Lists t where t.Id = A_TaskManager_Tasks.ListId )

		-----------------------------------------------------
		-- сетевые адреса рабочих мест = адресу сервера - заменяем брехней 
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = 'Ошибка в адресе' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null в 0 в ID юзеров по умолчанию ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		-- в 0 несуществующих юзеров по умолчанию -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		-- двоение юзеров по умолчанию в ссылках по линиям --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		-- удаляем несуществующие значения ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id From C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id From @uidt)
			or not UserB in (Select id From @uidt)
		
		-----------------------------------------------------
		-- Роли на удаленных юзеров -------------------------
		-----------------------------------------------------
		
		Delete From A_UserRoles_Roles
		Where (Domination = 1)
			and ( not Id in (Select id From A_Users))
			
		Delete
		From A_UserRoles_RolesOfUsers
		Where not IdUser in (Select Id From A_Users)
	
		Delete
		From A_UserRoles_RolesOfUsers
		Where not IdRole in (Select Id From A_UserRoles_Roles)
		
		Delete
		From A_UserRoles_RightsOfRoles
		Where not IdRole in (Select Id From A_UserRoles_Roles)

		-----------------------------------------------------
		-- Редиректы на удаленных юзеров --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		-- Пустые группы, номера, несвязанные правила -------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		exec A_Admin_Number_SiftByActions
		
		exec A_Admin_Rule_SiftByNumbers
		
		-----------------------------------------------------
		-- неиспользуемые плагин-модули ---------------------
		-----------------------------------------------------
		Delete From A_PluginMenu_User
		Where not exists ( Select Id From A_Users u Where u.Id = A_PluginMenu_User.IdUser )

		-----------------------------------------------------
		-- канонические адреса ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address
		
		-----------------------------------------------------	
		-- Очистка пустых ссылок в таблицах политики прав доступа к объектам
		-----------------------------------------------------	
		exec dbo.A_Policy_CheckFilter
end
GO
