﻿--------------------------------------------------
-----     Удаление таблиц из базы oktell     -----
--------------------------------------------------

------------------------------
-- WO_Dashboards_Dashboards --
------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Dashboards]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Dashboards]
GO

----------------------------
-- WO_Dashboards_Sections --
----------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Sections]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Sections]
GO

---------------------------
-- WO_Dashboards_Widgets --
---------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Widgets]
GO

----------------------------------
-- WO_Dashboards_Widgets_Fields --
----------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Fields]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Widgets_Fields]
GO

----------------------------------------
-- WO_Dashboards_Widgets_Fields_Value --
----------------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Fields_Value]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Widgets_Fields_Value]
GO

-----------------------------------
-- WO_Dashboards_Widgets_Filters --
-----------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Filters]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Widgets_Filters]
GO

---------------------------------------------
-- WO_Dashboards_Widgets_Filters_Operation --
---------------------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Filters_Operation]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Widgets_Filters_Operation]
GO

----------------------------------
-- WO_Dashboards_Widgets_Source --
----------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Source]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Widgets_Source]
GO

---------------------------------
-- WO_Dashboards_Widgets_Types --
---------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Types]', 'U'))
DROP TABLE [dbo].[WO_Dashboards_Widgets_Types]
GO

---------------------------------------------------------
-----     Создание таблиц в базе oktell_settings    -----
---------------------------------------------------------

------------------------------
-- WO_Dashboards_Dashboards --
------------------------------

IF  EXISTS (SELECT * FROM oktell_settings.dbo.sysobjects WHERE id = OBJECT_ID(N'[oktell_settings].[dbo].[WO_Dashboards_Dashboards]', 'U'))
DROP TABLE [oktell_settings].[dbo].[WO_Dashboards_Dashboards]
GO

CREATE TABLE [oktell_settings].[dbo].[WO_Dashboards_Dashboards](
	[Id] [uniqueidentifier] NOT NULL,
	[IdProject] [uniqueidentifier] NULL,
	[Name] [nvarchar](100) NULL,
	[Creator] [uniqueidentifier] NULL,
	[CreationDate] [datetime] NULL,
 CONSTRAINT [PK_WO_Dashboards] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
) ON [PRIMARY]
) ON [PRIMARY]

GO

----------------------------
-- WO_Dashboards_Sections --
----------------------------

IF  EXISTS (SELECT * FROM oktell_settings.dbo.sysobjects WHERE id = OBJECT_ID(N'[oktell_settings].[dbo].[WO_Dashboards_Sections]', 'U'))
DROP TABLE [oktell_settings].[dbo].[WO_Dashboards_Sections]
GO

CREATE TABLE [oktell_settings].[dbo].[WO_Dashboards_Sections](
	[Id] [uniqueidentifier] NOT NULL,
	[Name] [nvarchar](100) NULL,
	[CreationDate] [datetime] NULL,
	[Position] [int] NULL,
	[IdDashboard] [uniqueidentifier] NULL,
 CONSTRAINT [PK_WO_DashboardsSections] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [oktell_settings].[dbo].[WO_Dashboards_Sections] ADD  CONSTRAINT [DF_WO_DashboardsSections_Position]  DEFAULT (NULL) FOR [Position]
GO

---------------------------
-- WO_Dashboards_Widgets --
---------------------------

IF  EXISTS (SELECT * FROM oktell_settings.dbo.sysobjects WHERE id = OBJECT_ID(N'[oktell_settings].[dbo].[WO_Dashboards_Widgets]', 'U'))
DROP TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets]
GO

CREATE TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets](
	[Id] [uniqueidentifier] NOT NULL,
	[IdSection] [uniqueidentifier] NULL,
	[Name] [nvarchar](100) NULL,
	[Type] [int] NULL,
	[Source] [int] NULL,
	[IdFields] [uniqueidentifier] NULL,
	[IdFilters] [uniqueidentifier] NULL,
	[NameTable] [nvarchar](100) NULL,
	[Query] [ntext] NULL,
	[OrderBy] [nvarchar](100) NULL,
	[ShowTopRows] [int] NULL,
	[Options] [ntext] NULL,
 CONSTRAINT [PK_WO_SectionsWidgets] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

----------------------------------
-- WO_Dashboards_Widgets_Fields --
----------------------------------

IF  EXISTS (SELECT * FROM oktell_settings.dbo.sysobjects WHERE id = OBJECT_ID(N'[oktell_settings].[dbo].[WO_Dashboards_Widgets_Fields]', 'U'))
DROP TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets_Fields]
GO

CREATE TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets_Fields](
	[Id] [uniqueidentifier] NOT NULL,
	[IdFields] [uniqueidentifier] NULL,
	[Name] [nvarchar](100) NULL,
	[Value] [int] NULL,
 CONSTRAINT [PK_WO_Dashboards_Widgets_Fields] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
) ON [PRIMARY]
) ON [PRIMARY]

GO

-----------------------------------
-- WO_Dashboards_Widgets_Filters --
-----------------------------------

IF  EXISTS (SELECT * FROM oktell_settings.dbo.sysobjects WHERE id = OBJECT_ID(N'[oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters]', 'U'))
DROP TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters]
GO

CREATE TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters](
	[Id] [uniqueidentifier] NOT NULL,
	[IdFilters] [uniqueidentifier] NULL,
	[Name] [nvarchar](100) NULL,
	[Operation] [int] NULL,
	[Value] [nvarchar](100) NULL,
 CONSTRAINT [PK_WO_Dashboards_Widgets_Filters] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
) ON [PRIMARY]
) ON [PRIMARY]

GO

---------------------------------------------
-- WO_Dashboards_Widgets_Filters_Operation --
---------------------------------------------

IF  EXISTS (SELECT * FROM oktell_settings.dbo.sysobjects WHERE id = OBJECT_ID(N'[oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation]', 'U'))
DROP TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation]
GO

CREATE TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation](
	[Id] [int] IDENTITY(0,1) NOT NULL,
	--[Operation] [nvarchar](100) NULL,
	[OperationText] [nvarchar](50) NULL,
 CONSTRAINT [PK_WO_Dashboards_Widgets_Filters_Operation] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
) ON [PRIMARY]
) ON [PRIMARY]

GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.WO_Dashboards_Widgets_Filters_Operation_Fill' ))
	Drop procedure dbo.WO_Dashboards_Widgets_Filters_Operation_Fill
GO

CREATE procedure [dbo].[WO_Dashboards_Widgets_Filters_Operation_Fill]
as
begin
	
	TRUNCATE TABLE [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation]
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('=')
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('!=')
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('>')
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('<')
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('like ''%_%''')
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('not like ''%_%''')
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('like ''_%''')
	INSERT INTO [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation] (OperationText) VALUES ('like ''%_''')
	
end
GO

-------------------------------------------------------------------------------
-----     Создание представлений в базе oktell на таблицы базы oktell     -----
-------------------------------------------------------------------------------

------------------------------
-- WO_Dashboards_Dashboards --
------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Dashboards]', 'V'))
DROP VIEW [dbo].[WO_Dashboards_Dashboards]
GO

CREATE VIEW [dbo].[WO_Dashboards_Dashboards]
AS
	SELECT	*
	FROM [oktell_settings].[dbo].[WO_Dashboards_Dashboards]
GO

----------------------------
-- WO_Dashboards_Sections --
----------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Sections]', 'V'))
DROP VIEW [dbo].[WO_Dashboards_Sections]
GO

CREATE VIEW [dbo].[WO_Dashboards_Sections]
AS
	SELECT	*
	FROM [oktell_settings].[dbo].[WO_Dashboards_Sections]
GO

---------------------------
-- WO_Dashboards_Widgets --
---------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets]', 'V'))
DROP VIEW [dbo].[WO_Dashboards_Widgets]
GO

CREATE VIEW [dbo].[WO_Dashboards_Widgets]
AS
	SELECT	*
	FROM [oktell_settings].[dbo].[WO_Dashboards_Widgets]
GO

----------------------------------
-- WO_Dashboards_Widgets_Fields --
----------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Fields]', 'V'))
DROP VIEW [dbo].[WO_Dashboards_Widgets_Fields]
GO

CREATE VIEW [dbo].[WO_Dashboards_Widgets_Fields]
AS
	SELECT	*
	FROM [oktell_settings].[dbo].[WO_Dashboards_Widgets_Fields]
GO


IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Filters]', 'V'))
DROP VIEW [dbo].[WO_Dashboards_Widgets_Filters]
GO

CREATE VIEW [dbo].[WO_Dashboards_Widgets_Filters]
AS
	SELECT	*
	FROM [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters]
GO

---------------------------------------------
-- WO_Dashboards_Widgets_Filters_Operation --
---------------------------------------------

IF  EXISTS (SELECT * FROM oktell.dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[WO_Dashboards_Widgets_Filters_Operation]', 'V'))
DROP VIEW [dbo].[WO_Dashboards_Widgets_Filters_Operation]
GO

CREATE VIEW [dbo].[WO_Dashboards_Widgets_Filters_Operation]
AS
	SELECT	*
	FROM [oktell_settings].[dbo].[WO_Dashboards_Widgets_Filters_Operation]
GO

-------------------------------------
-----     Создание процедур     -----
-------------------------------------

------------------------------------
-- WO_Dashboards_Dashboard_Create --
------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Dashboard_Create]'))
DROP procedure [dbo].[WO_Dashboards_Dashboard_Create]
GO

CREATE procedure [dbo].[WO_Dashboards_Dashboard_Create]
	@authorizeduserid	uniqueidentifier,
	@dashboardname	nvarchar(100),
	@projectid	nvarchar(50)
as
begin
	
	declare	@dashboardid uniqueidentifier
	set	@dashboardid = newid()
	
	if ( @projectid like '' )
		Set @projectid = NULL
	
	-- Добавление нового дашборда
	insert into [dbo].[WO_Dashboards_Dashboards]
		select	@dashboardid,
				@projectid,
				@dashboardname,
				@authorizeduserid,
				getutcdate()
	
	select	@dashboardid dashboardid
	
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии
	   только если это не авто список для задач из IVR (признак - отсутствие привязки к проекту)
	*/
	exec A_Policy_Objects_Save
		@idObject = @dashboardid,
		@type = 105,
		@name = @dashboardname,
		@idParentProject = @projectid,
		@actionUserId = @authorizeduserid
	
end
GO

---------------------------------
-- WO_Dashboards_Dashboard_Get --
---------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Dashboard_Get]'))
DROP procedure [dbo].[WO_Dashboards_Dashboard_Get]
GO

CREATE procedure [dbo].[WO_Dashboards_Dashboard_Get]
	@authorizeduserid	uniqueidentifier,
	@dashboardid    uniqueidentifier
as
begin
	
	-- Проект какой у дашборда?
	Declare @projectid uniqueidentifier	
	Select @projectid = d.IdProject
	From [dbo].[WO_Dashboards_Dashboards] d
	Where d.Id = @dashboardid
			
	/* Привилегия чтения по проекту есть?
	*/
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#pp' ))
		Drop table #pp
	Create table #pp ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #pp ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObject
			@iduser = @authorizeduserid,
			@idobject = @projectid,
			@idprivilege = 'F876E650-7972-475A-AE96-BCCF831AF818'			
	
	/* Привилегия чтения по дашборду есть?
	*/
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#dp' ))
		Drop table #dp
	Create table #dp ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #dp ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObject
			@iduser = @authorizeduserid,
			@idobject = @dashboardid,
			@idprivilege = '95176304-7E76-46FE-A473-0DF01F29B863'			
			
	
	-- Достаем из пересечения
	Select	d.Id,
			d.IdProject,
			d.Name,
			d.Creator,
			d.CreationDate
	From	[dbo].[WO_Dashboards_Dashboards] d
		Inner join #dp dp on dp.IdObject = d.Id
	Where (d.Id = @dashboardid)	
		and ((d.IdProject is NULL ) 
			or (exists (Select idObject From #pp pp Where pp.idObject = d.IdProject)))
	
end
GO

------------------------------------
-- WO_Dashboards_Dashboard_Remove --
------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Dashboard_Remove]'))
DROP procedure [dbo].[WO_Dashboards_Dashboard_Remove]
GO

CREATE procedure [dbo].[WO_Dashboards_Dashboard_Remove]
	@authorizeduserid	uniqueidentifier,
	@dashboardid	uniqueidentifier
as
begin
	
	-- Сами дашборды
	delete
	from	[dbo].[WO_Dashboards_Dashboards]
	where	Id = @dashboardid
	
	-- Привязанные поля
	delete
	from	[dbo].[WO_Dashboards_Widgets_Fields]
	where	IdFields in
						(
							select	IdFields
							from	[dbo].[WO_Dashboards_Widgets]
							where	Id in
											(
												select	Id
												from	[dbo].[WO_Dashboards_Widgets]
												where	IdSection in
																		(
																			select	Id
																			from	[dbo].[WO_Dashboards_Sections]
																			where	IdDashboard = @dashboardid
																		)
											)
						)
	
	-- Фильтры
	delete
	from	[dbo].[WO_Dashboards_Widgets_Filters]
	where	IdFilters in
						(
							select	IdFilters
							from	[dbo].[WO_Dashboards_Widgets]
							where	Id in
											(
												select	Id
												from	[dbo].[WO_Dashboards_Widgets]
												where	IdSection in
																		(
																			select	Id
																			from	[dbo].[WO_Dashboards_Sections]
																			where	IdDashboard = @dashboardid
																		)
											)
						)
	
	-- Виджеты
	delete
	from	[dbo].[WO_Dashboards_Widgets]
	where	IdSection in
						(
							select	Id
							from	[dbo].[WO_Dashboards_Sections]
							where	IdDashboard = @dashboardid
						)
	
	-- Борды
	delete
	from	[dbo].[WO_Dashboards_Sections]
	where	IdDashboard = @dashboardid
	
	
	-- Из таблиц политики прав доступа к объектам
	exec A_Policy_Objects_Remove @dashboardid
	
end
GO

------------------------------------
-- WO_Dashboards_Dashboard_Rename --
------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Dashboard_Rename]'))
DROP procedure [dbo].[WO_Dashboards_Dashboard_Rename]
GO

CREATE procedure [dbo].[WO_Dashboards_Dashboard_Rename]
	@authorizeduserid	uniqueidentifier,
	@dashboardid	uniqueidentifier,
	@dashboardnewname	nvarchar(100)
as
begin
	
	-- Обновляет название
	Update [dbo].[WO_Dashboards_Dashboards]
	Set	Name = @dashboardnewname
	Where Id = @dashboardid
	
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии
	*/
	exec A_Policy_Objects_Save
		@idObject = @dashboardid,
		@type = 105,
		@name = @dashboardnewname,
		@idParentProject = NULL, --во время переименования не волнует
		@actionUserId = @authorizeduserid
	
end
GO

--------------------------------------
-- WO_Dashboards_Dashboards_GetList --
--------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Dashboards_GetList]'))
DROP procedure [dbo].[WO_Dashboards_Dashboards_GetList]
GO

CREATE procedure [dbo].[WO_Dashboards_Dashboards_GetList]
	@authorizeduserid	uniqueidentifier
as
begin

	-- Доступные пользователю проекты по привилегии ЧТЕНИЕ
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#projects' ))
		Drop table #projects
	Create table #projects ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #projects ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @authorizeduserid,
			@objecttype = 101,
			--@idparentproject = NULL,
			@idprivilege = 'F876E650-7972-475A-AE96-BCCF831AF818'

	-- Доступные пользователю дашборды по привилегии ЧТЕНИЕ
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#dashboards' ))
		Drop table #dashboards
	Create table #dashboards ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #dashboards ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @authorizeduserid,
			@objecttype = 105,
			--@idparentproject = NULL,
			@idprivilege = '95176304-7E76-46FE-A473-0DF01F29B863'

	
	Select	d.Id,
			d.IdProject,
			d.Name,
			d.Creator,
			d.CreationDate
	From	[dbo].[WO_Dashboards_Dashboards] d
		Inner join #dashboards p on p.IdObject = d.Id
	Where ( d.IdProject is NULL )
		or exists ( Select IdObject From #projects pr Where pr.IdObject = d.IdProject )
	Order by d.Name asc
	
end
GO

--------------------------------------
-- WO_Dashboards_Dashboards_GetList --
--------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Dashboards_GetListPrivileges]'))
DROP procedure [dbo].[WO_Dashboards_Dashboards_GetListPrivileges]
GO

CREATE procedure [dbo].[WO_Dashboards_Dashboards_GetListPrivileges]
	@authorizeduserid	uniqueidentifier
as
begin

	-- Возвращает информацию о привилегиях пользователя по всем дашбордам
	
	-- Привилегии доступные пользователю по дашбордам
	if exists ( Select * from tempdb..sysobjects where id=object_id ( 'tempdb..#privileges' ))
		Drop table #privileges
	Create table #privileges ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #privileges ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @authorizeduserid,
			@objecttype = 105
			--@idparentproject = NULL,
			--@idprivilege = '495DEB4D-D5FF-4C52-A219-541C3AEC6CAC'


	-- Набор привилегий для каждого из доступных дашбордов
	Select [idObject], [idPrivilege], [code]
	From #privileges
	Order by [idObject]
	
end
GO

------------------------------------
-- WO_Dashboards_Projects_GetList --
------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Projects_GetList]'))
DROP procedure [dbo].[WO_Dashboards_Projects_GetList]
GO

CREATE procedure [dbo].[WO_Dashboards_Projects_GetList]
	@authorizeduserid	uniqueidentifier
as
begin

	-- Доступные пользователю проекты по привилегии ЧТЕНИЕ
	if exists ( Select * from tempdb..sysobjects where id=object_id ( 'tempdb..#projects' ))
		Drop table #projects
	Create table #projects ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #projects ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @authorizeduserid,
			@objecttype = 101,
			--@idparentproject = NULL,
			@idprivilege = 'F876E650-7972-475A-AE96-BCCF831AF818'
			
	
	-- Достаем инфу по проектам
	Select	p.Id,
			p.Name
	From [oktell_settings].[dbo].[A_TaskManager_Projects] p
		Inner join #projects pp on pp.idObject = p.Id
	Order by p.Name asc
	
end
GO

----------------------------------
-- WO_Dashboards_Section_Create --
----------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Section_Create]'))
DROP procedure [dbo].[WO_Dashboards_Section_Create]
GO

CREATE procedure [dbo].[WO_Dashboards_Section_Create]
	@authorizeduserid	uniqueidentifier,
	@dashboardid	uniqueidentifier,
	@sectionname	nvarchar(100)
as
begin

--declare	@authorizeduserid uniqueidentifier = '36A8106C-2451-45D0-993E-2D23F321EDAC'
--declare	@dashboardid uniqueidentifier = newid()
--declare	@selectionname nvarchar(100) = 'Новый раздел'
	
	declare	@sectionid uniqueidentifier
		set	@sectionid = newid()
	
	insert into [dbo].[WO_Dashboards_Sections]
		select	@sectionid,
				@sectionname,
				getutcdate(),
				null,
				@dashboardid
	
	select	@sectionid sectionid
	
end
GO

----------------------------------
-- WO_Dashboards_Section_Remove --
----------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Section_Remove]'))
DROP procedure [dbo].[WO_Dashboards_Section_Remove]
GO

CREATE procedure [dbo].[WO_Dashboards_Section_Remove]
	@authorizeduserid	uniqueidentifier,
	@sectionid	uniqueidentifier
as
begin

--declare	@authorizeduserid uniqueidentifier = '36A8106C-2451-45D0-993E-2D23F321EDAC'
--declare	@sectionid uniqueidentifier = '56FDCB1D-8FB5-4154-871C-BBFAEADCD208'
	
	delete
	from	[dbo].[WO_Dashboards_Sections]
	where	Id = @sectionid
	
	delete
	from	[dbo].[WO_Dashboards_Widgets_Fields]
	where	IdFields in
						(
							select	IdFields
							from	[dbo].[WO_Dashboards_Widgets]
							where	Id in
											(
												select	Id
												from	[dbo].[WO_Dashboards_Widgets]
												where	IdSection = @sectionid
											)
						)
	
	delete
	from	[dbo].[WO_Dashboards_Widgets_Filters]
	where	IdFilters in
						(
							select	IdFilters
							from	[dbo].[WO_Dashboards_Widgets]
							where	Id in
											(
												select	Id
												from	[dbo].[WO_Dashboards_Widgets]
												where	IdSection = @sectionid
											)
						)
	
	delete
	from	[dbo].[WO_Dashboards_Widgets]
	where	IdSection = @sectionid
	
end
GO

----------------------------------
-- WO_Dashboards_Section_Rename --
----------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Section_Rename]'))
DROP procedure [dbo].[WO_Dashboards_Section_Rename]
GO

CREATE procedure [dbo].[WO_Dashboards_Section_Rename]
	@authorizeduserid	uniqueidentifier,
	@sectionid	uniqueidentifier,
	@sectionnewname	nvarchar(100)
as
begin

--declare	@authorizeduserid uniqueidentifier = '36A8106C-2451-45D0-993E-2D23F321EDAC'
--declare	@selectionid uniqueidentifier = '56FDCB1D-8FB5-4154-871C-BBFAEADCD208'
--declare	@selectionnewname nvarchar(100) = 'Новый раздел 2'
	
	update	[dbo].[WO_Dashboards_Sections]
	set	Name = @sectionnewname
	where	Id = @sectionid
	
end
GO

------------------------------------
-- WO_Dashboards_Sections_GetList --
------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Sections_GetList]'))
DROP procedure [dbo].[WO_Dashboards_Sections_GetList]
GO

CREATE procedure [dbo].[WO_Dashboards_Sections_GetList]
	@authorizeduserid	uniqueidentifier,
	@dashboardid	uniqueidentifier
as
begin

--declare	@authorizeduserid uniqueidentifier = '36A8106C-2451-45D0-993E-2D23F321EDAC'
--declare	@dashboardid uniqueidentifier = '4CDC0C6C-DC1D-4D1C-B056-1E5961732BBD'
	
	select	Id,
			Name
	from	[dbo].[WO_Dashboards_Sections]
	where	IdDashboard = @dashboardid
	order by isnull(Position, 2147483647) asc, CreationDate asc
	
end
GO

-------------------------------------------
-- WO_Dashboards_Widget_Query_Fields_Get --
-------------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widget_Query_Fields_Get]'))
DROP procedure [dbo].[WO_Dashboards_Widget_Query_Fields_Get]
GO

CREATE procedure [dbo].[WO_Dashboards_Widget_Query_Fields_Get]
	@authorizeduserid	uniqueidentifier,
	@querytext	ntext
as
begin
	
	exec	('set fmtonly on ' + @querytext)
	
end
GO

---------------------------------
-- WO_Dashboards_Widget_Remove --
---------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widget_Remove]'))
DROP procedure [dbo].[WO_Dashboards_Widget_Remove]
GO

CREATE procedure [dbo].[WO_Dashboards_Widget_Remove]
	@authorizeduserid	uniqueidentifier,
	@widgetid	uniqueidentifier
as
begin

--declare	@authorizeduserid uniqueidentifier = '36A8106C-2451-45D0-993E-2D23F321EDAC'
--declare	@widgetid uniqueidentifier = '56FDCB1D-8FB5-4154-871C-BBFAEADCD208'
	
	delete
	from	[dbo].[WO_Dashboards_Widgets_Fields]
	where	IdFields =
						(
							select	IdFields
							from	[dbo].[WO_Dashboards_Widgets]
							where	Id = @widgetid
						)
	
	delete
	from	[dbo].[WO_Dashboards_Widgets_Filters]
	where	IdFilters =
						(
							select	IdFilters
							from	[dbo].[WO_Dashboards_Widgets]
							where	Id = @widgetid
						)
	
	delete
	from	[dbo].[WO_Dashboards_Widgets]
	where	Id = @widgetid
	
end
GO

-------------------------------
-- WO_Dashboards_Widget_Save --
-------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widget_Save]'))
DROP procedure [dbo].[WO_Dashboards_Widget_Save]
GO

CREATE procedure [dbo].[WO_Dashboards_Widget_Save]
	@authorizeduserid	uniqueidentifier,
	@sectionid	uniqueidentifier,
	@widgetparams	ntext
as
begin
	
	declare	@widgetnewid uniqueidentifier
		set	@widgetnewid = newid()
	declare	@widgetfieldsnewid uniqueidentifier
		set	@widgetfieldsnewid = newid()
	declare	@widgetfiltersnewid uniqueidentifier
		set	@widgetfiltersnewid = newid()
	
	declare	@widgetid uniqueidentifier
	declare	@widgetname nvarchar(100)
	declare	@widgettype int
	declare	@widgetsource int
	
	
	declare	@ixml int
	
	
	
	exec sp_xml_preparedocument @ixml output, @widgetparams
	--------------------------------------------------
	
	-- Создаем табличные переменные для хранения данных о проверках
	declare @tempxmldata table
		(
			[id] nvarchar(50) collate database_default,
			[name] nvarchar(100) collate database_default,
			[type] nvarchar(5) collate database_default,
			[source] nvarchar(5) collate database_default,
			[table_name] nvarchar(100) collate database_default,
			[query] ntext collate database_default,
			[order_by] nvarchar(100) collate database_default,
			[show_top_rows] nvarchar(10) collate database_default,
			[options] ntext collate database_default
		)
	
	declare @tempxmldatafields table
		(
			[name] nvarchar(100) collate database_default,
			[value] nvarchar(5) collate database_default
		)
	
	declare @tempxmldatafilters table
		(
			[name] nvarchar(100) collate database_default,
			[operation] nvarchar(5) collate database_default,
			[value] nvarchar(100) collate database_default
		)
	
	-- Заполняем табличные переменные данными о проверках, которые требуется выполнить
	insert into @tempxmldata
		select	*
		from openxml (@ixml,  '/root', 2)
		with	(
					[id] nvarchar(50) 'id',
					[name] nvarchar(100) 'name',
					[type] nvarchar(5) 'type',
					[source] nvarchar(5) 'source',
					[table_name] nvarchar(100) 'table_name',
					[query] ntext 'query',
					[order_by] nvarchar(100) 'order_by',
					[show_top_rows] nvarchar(10) 'show_top_rows',
					[options] ntext 'options'
				)
	
	--select * from @tempxmldata
	
	
	insert into @tempxmldatafields
		select	*
		from openxml (@ixml,  '/root/table_fields', 2)
		with	(
					[name] nvarchar(100) 'name',
					[value] nvarchar(5) 'value'
				)
	
	--select * from @tempxmldatafields
	
	
	insert into @tempxmldatafilters
		select	*
		from openxml (@ixml,  '/root/table_filter', 2)
		with	(
					[name] nvarchar(100) 'name',
					[operation] nvarchar(5) 'operation',
					[value] nvarchar(100) 'value'
				)
	
	--select * from @tempxmldatafilters
	
	--------------------------------
	exec sp_xml_removedocument @ixml
	
	
	
	if ((select [id] from @tempxmldata) is null or (select [id] from @tempxmldata) = '')
		begin
			--select	'new'
			-- Widget новый (добавляем)
			
			-- Заполнение [dbo].[WO_Dashboards_Widgets]
			insert into [dbo].[WO_Dashboards_Widgets] ([Id], [IdSection], [Name], [Type], [Source], [IdFields], [IdFilters], [NameTable], [Query], [OrderBy], [ShowTopRows], [Options])
				select	@widgetnewid [Id],
						@sectionid [IdSection],
						txmld.name [Name],
						case when txmld.type = '' then null else cast(txmld.type as int) end [Type],
						case when txmld.source = '' then null else cast(txmld.source as int) end [Source],
						@widgetfieldsnewid [IdFields],
						@widgetfiltersnewid [IdFilters],
						txmld.table_name [NameTable],
						txmld.query [Query],
						txmld.order_by [OrderBy],
						case when txmld.show_top_rows = '' then null else cast(txmld.show_top_rows as int) end [ShowTopRows],
						txmld.options [Options]
				from	@tempxmldata txmld
			
			-- Заполнение [dbo].[WO_Dashboards_Widgets_Fields]
			insert into [dbo].[WO_Dashboards_Widgets_Fields] ([Id], [IdFields], [Name], [Value])
				select	newid() [Id],
						@widgetfieldsnewid [IdFields],
						txmldf.name [Name],
						case when txmldf.value = '' then null else cast(txmldf.value as int) end [Value]
				from	@tempxmldatafields txmldf
				where	txmldf.name is not null and txmldf.value is not null					-- update 2013-10-30
			
			-- Заполнение [dbo].[WO_Dashboards_Widgets_Filters]
			insert into [dbo].[WO_Dashboards_Widgets_Filters] ([Id], [IdFilters], [Name], [Operation], [Value])
				select	newid() [Id],
						@widgetfiltersnewid [IdFields],
						txmldfl.name [Name],
						case when txmldfl.operation = '' then null else cast(txmldfl.operation as int) end [Operation],
						txmldfl.value [Value]
				from	@tempxmldatafilters txmldfl
				where	txmldfl.name is not null and txmldfl.operation is not null					-- update 2013-10-30
			
			
			select	@widgetnewid WidgetId
		end
	else
		begin
			--select	'old'
			-- Widget есть уже такой (изменяем)
			
			-- Если какой-то из параметров не высылается (null) считаем, что он не менялся
			
			-- IdSection
			if ((select IdSection from [dbo].[WO_Dashboards_Widgets] where Id = (select cast([id] as uniqueidentifier) from @tempxmldata)) != @sectionid)
				update [dbo].[WO_Dashboards_Widgets] set [IdSection] = @sectionid
				where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
			-- Name
			if ((select [name] from @tempxmldata) is not null)
				update [dbo].[WO_Dashboards_Widgets] set [Name] = (select [name] from @tempxmldata)
				where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
			-- Type
			if ((select [type] from @tempxmldata) is not null)
				update [dbo].[WO_Dashboards_Widgets] set [Type] = (select case when [type] = '' then null else cast([type] as int) end from @tempxmldata)
				where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
			-- Source
			if ((select [source] from @tempxmldata) is not null)
				update [dbo].[WO_Dashboards_Widgets] set [Source] = (select case when [source] = '' then null else cast([source] as int) end from @tempxmldata)
				where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
			
			
			
			-- Проверка, есть ли изменения в fields. Если нет, то оставляем как есть, иначе ...
			if ((select count(*) from @tempxmldatafields) != 0)
				begin
					--select	'Есть fields'
					-- Перезаписываем все
					
					-- ... удаляем
					delete
						from	[dbo].[WO_Dashboards_Widgets_Fields]
						where	Id in
									(
										select	Id
										from	[dbo].[WO_Dashboards_Widgets_Fields]
										where	IdFields =
															(
																select	IdFields
																from	[dbo].[WO_Dashboards_Widgets]
																where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
															)
									)
					-- ... записываем новые
					insert into [dbo].[WO_Dashboards_Widgets_Fields] ([Id], [IdFields], [Name], [Value])
						select	newid() [Id],
								(
									select	IdFields
									from	[dbo].[WO_Dashboards_Widgets]
									where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
								) [IdFields],
								txmldf.name [Name],
								case when txmldf.value = '' then null else cast(txmldf.value as int) end [Value]
						from	@tempxmldatafields txmldf
						-- исключая непривязанные id-ки
						where	(
									select	IdFields
									from	[dbo].[WO_Dashboards_Widgets]
									where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
								) is not null
								and txmldf.name is not null and txmldf.value is not null					-- update 2013-10-22
				end
				
				
				
			-- Проверка, есть ли изменения в filters. Если нет, то оставляем как есть, иначе ...
			if ((select count(*) from @tempxmldatafilters) != 0)
				begin
					--select	'Есть filters'
					-- Перезаписываем все
					
					-- ... удаляем
					delete
						from	[dbo].[WO_Dashboards_Widgets_Filters]
						where	Id in
									(
										select	Id
										from	[dbo].[WO_Dashboards_Widgets_Filters]
										where	IdFilters =
															(
																select	IdFilters
																from	[dbo].[WO_Dashboards_Widgets]
																where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
															)
									)
					-- ... записываем новые
					insert into [dbo].[WO_Dashboards_Widgets_Filters] ([Id], [IdFilters], [Name], [Operation], [Value])
						select	newid() [Id],
								(
									select	IdFilters
									from	[dbo].[WO_Dashboards_Widgets]
									where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
								) [IdFilters],
								txmldfl.name [Name],
								case when txmldfl.operation = '' then null else cast(txmldfl.operation as int) end [Operation],
								txmldfl.value [Value]
						from	@tempxmldatafilters txmldfl
						-- исключая непривязанные id-ки
						where	(
									select	IdFilters
									from	[dbo].[WO_Dashboards_Widgets]
									where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
								) is not null
								and txmldfl.name is not null and txmldfl.operation is not null					-- update 2013-10-22
				end
			
			
			-- NameTable
			if ((select [table_name] from @tempxmldata) is not null)
				update [dbo].[WO_Dashboards_Widgets] set [NameTable] = (select [table_name] from @tempxmldata)
				where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
			-- Query
			if ((select cast([query] as nvarchar(4000)) from @tempxmldata) is not null)
				update w
				set w.[Query] = txd.[query]
				from	[dbo].[WO_Dashboards_Widgets] w, @tempxmldata txd
				where	w.[Id] = cast(txd.[id] as uniqueidentifier)
			-- OrderBy
			if ((select [order_by] from @tempxmldata) is not null)
				update [dbo].[WO_Dashboards_Widgets] set [OrderBy] = (select [order_by] from @tempxmldata)
				where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
			-- [ShowTopRows]
			if ((select [show_top_rows] from @tempxmldata) is not null)
				update [dbo].[WO_Dashboards_Widgets] set [ShowTopRows] = (select case when [show_top_rows] = '' then null else cast([show_top_rows] as int) end from @tempxmldata)
				where	[Id] = (select cast([id] as uniqueidentifier) from @tempxmldata)
			-- Options
			if ((select cast([options] as nvarchar(4000)) from @tempxmldata) is not null)
				update w
				set	w.[Options] = txd.[options]
				from	[dbo].[WO_Dashboards_Widgets] w, @tempxmldata txd
				where	w.[Id] = cast(txd.[id] as uniqueidentifier)
			
			
		end
		
					
end
GO

-----------------------------------------------
-- WO_Dashboards_Widget_Table_Fields_GetList --
-----------------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widget_Table_Fields_GetList]'))
DROP procedure [dbo].[WO_Dashboards_Widget_Table_Fields_GetList]
GO

CREATE procedure [dbo].[WO_Dashboards_Widget_Table_Fields_GetList]
	@authorizeduserid	uniqueidentifier,
	@tablename	nvarchar(1000)
as
begin
	
	select	f.name FieldName
	from	[dbo].[sysobjects] t, [dbo].[syscolumns] f
	where	t.id = f.id
			and t.type in ('U', 'V')
			and t.name = @tablename
	
end
GO

-----------------------------------------
-- WO_Dashboards_Widget_Tables_GetList --
-----------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widget_Tables_GetList]'))
DROP procedure [dbo].[WO_Dashboards_Widget_Tables_GetList]
GO

CREATE procedure [dbo].[WO_Dashboards_Widget_Tables_GetList]
	@authorizeduserid	uniqueidentifier
as
begin
	
	select	t.name TableName
	from	[dbo].[sysobjects] t
	where	t.type in ('U', 'V')
	order by t.name asc
	
end
GO

-------------------------------------
-- WO_Dashboards_Widgets_GetConfig --
-------------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widgets_GetConfig]'))
DROP procedure [dbo].[WO_Dashboards_Widgets_GetConfig]
GO

CREATE procedure [dbo].[WO_Dashboards_Widgets_GetConfig]
	@authorizeduserid	uniqueidentifier,
	@widgetid	uniqueidentifier
as
begin

--declare	@authorizeduserid uniqueidentifier = '36A8106C-2451-45D0-993E-2D23F321EDAC'
--declare	@sectionid uniqueidentifier = newid()
	
	select	NameTable TableName,
			Query
	from	[dbo].[WO_Dashboards_Widgets]
	where	Id = @widgetid
	
	select	wf.Name WidgetFilterName,
			wf.Operation WidgetFilterOperation,
			wf.Value WidgetFilterValue
	from	[dbo].[WO_Dashboards_Widgets] w 
				inner join [dbo].[WO_Dashboards_Widgets_Filters] wf on w.IdFilters = wf.IdFilters
	where	w.Id = @widgetid
	
end
GO

-----------------------------------
-- WO_Dashboards_Widgets_GetData --
-----------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widgets_GetData]'))
DROP procedure [dbo].[WO_Dashboards_Widgets_GetData]
GO

CREATE procedure [dbo].[WO_Dashboards_Widgets_GetData]
	@authorizeduserid	uniqueidentifier,
	@widgetid	uniqueidentifier
as
begin
	
	
	-- таблица бд
	if ((select [Source] from [dbo].[WO_Dashboards_Widgets] where Id = @widgetid) = 1)
		begin
			--select	'таблица бд'
			
			declare	@sqltable nvarchar(4000)
			
			
			declare	@fields nvarchar(4000)
			set	@fields = ''
			select	@fields = @fields + wf.Name + ', '
			from	[dbo].[WO_Dashboards_Widgets] w 
						inner join [dbo].[WO_Dashboards_Widgets_Fields] wf on w.IdFields = wf.IdFields
			where	w.Id = @widgetid
			
			declare	@filters nvarchar(4000)
			set	@filters = ''
			select	@filters = @filters + w.OperationTextValue + ' and ' from
			(
				select	wf.Name +
						' ' +
						case
							when wfo.Id in (4,5,6,7) then replace(wfo.OperationText, '_', wf.Value)
							/*
							when wfo.Id = 4 then 'like ''%' + wf.Value + '%'''
							when wfo.Id = 5 then 'not like ''%' + wf.Value + '%'''
							when wfo.Id = 6 then 'like ''' + wf.Value + '%'''
							when wfo.Id = 7 then 'like ''%' + wf.Value + ''''
							*/
							else wfo.OperationText + ' ''' + wf.Value + ''''
						end OperationTextValue
				from	[dbo].[WO_Dashboards_Widgets] w
							inner join [dbo].[WO_Dashboards_Widgets_Filters] wf on w.IdFilters = wf.IdFilters
							inner join [dbo].[WO_Dashboards_Widgets_Filters_Operation] wfo on wf.Operation = wfo.Id
				where	w.Id = @widgetid
			) w
			
			
			
			set	@sqltable =
				case
					when ( select count(*) 
						   from [dbo].[WO_Dashboards_Widgets] w 
								inner join [dbo].[WO_Dashboards_Widgets_Fields] wf on w.IdFields = wf.IdFields 
						   where w.Id = @widgetid and wf.Name is not null and wf.Value is not null) = 0 
						then 'select null'					-- update 2013-10-28
					else
						'select ' +
							case 
								when (( select count(*) 
										from [dbo].[WO_Dashboards_Widgets] w 
										where (w.Id = @widgetid) 
											and (w.Type = 4) 
											and (w.ShowTopRows is not null)) != 0 ) 
									then 'top(' + cast((select w.ShowTopRows from [dbo].[WO_Dashboards_Widgets] w where w.Id = @widgetid) as varchar) + ') '
								else ''
							end +
						(left(@fields, len(@fields)-len(', '))) +
						' from ' +
						(
							select	w.NameTable
							from	[dbo].[WO_Dashboards_Widgets] w
							where	w.Id = @widgetid
						) +
						case
							when (( select count(*) 
								   from [dbo].[WO_Dashboards_Widgets] w 
										inner join [dbo].[WO_Dashboards_Widgets_Filters] wf on w.IdFilters = wf.IdFilters 
								   where (w.Id = @widgetid) and (wf.Name is not null) and (wf.Operation is not null)) = 0 ) 
								then ''					-- update 2013-10-28
							else
								' where ' + (left(@filters, len(@filters)-len(' and ')))
						end +
						case
							when (( select count(*) 
									from [dbo].[WO_Dashboards_Widgets] w 
									where (w.Id = @widgetid) and (w.Type = 4) and (w.OrderBy is not null) and (w.OrderBy != '')) != 0 ) 
								then ' order by ' + (select w.OrderBy from [dbo].[WO_Dashboards_Widgets] w where w.Id = @widgetid)
							else ''
						end
				end
			
						
			exec(@sqltable)
		end
	
	
	-- sql-запрос
	if ((select [Source] from [dbo].[WO_Dashboards_Widgets] where Id = @widgetid) = 2)
		begin
			
			--select	'sql-запрос'
			
			declare	@sqlquery nvarchar(4000)
			set	@sqlquery =
			(
				select	cast(w.Query as nvarchar(4000))
				from	[dbo].[WO_Dashboards_Widgets] w
				where	w.Id = @widgetid
			)
			
			exec(@sqlquery)
		end
	
end
GO

-----------------------------------
-- WO_Dashboards_Widgets_GetList --
-----------------------------------

IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widgets_GetList]'))
DROP procedure [dbo].[WO_Dashboards_Widgets_GetList]
GO

CREATE procedure [dbo].[WO_Dashboards_Widgets_GetList]
	@authorizeduserid	uniqueidentifier,
	@sectionid	uniqueidentifier
as
begin

--declare	@authorizeduserid uniqueidentifier = '36A8106C-2451-45D0-993E-2D23F321EDAC'
--declare	@sectionid uniqueidentifier = newid()
	
	select	Id,
			Name,
			Type,
			Source,
			Options
	from	[dbo].[WO_Dashboards_Widgets]
	where	IdSection = @sectionid
	
	select	w.Id WidgetId,
			wf.Name WidgetFieldName,
			wf.Value WidgetFieldValue
	from	[dbo].[WO_Dashboards_Widgets] w 
				inner join [dbo].[WO_Dashboards_Widgets_Fields] wf on w.IdFields = wf.IdFields
	where	w.IdSection = @sectionid
	
end
GO

--------------------------------------------------------------------------------------
IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].A_DB_RemoveTailsOnStart'))
DROP procedure [dbo].[A_DB_RemoveTailsOnStart]
GO

Create Procedure [dbo].[A_DB_RemoveTailsOnStart]
as
begin
		exec dbo.WO_Dashboards_Widgets_Filters_Operation_Fill
		
		-- динамические объекты карты сети 
		exec dbo.A_DynamicConfig_Clear

		-- Регистрации 
		exec dbo.A_StreamRegistration_Clear
		
		-- Обновление кэша политики прав доступа к объектам
		exec dbo.A_Policy_SubjectGroupCache_CheckUpdate
		
		
		-- Прочие хвосты
		exec dbo.A_DB_RemoveTails
end
GO