﻿
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Registrar_DropSession' ))
	Drop procedure [dbo].[A_Registrar_DropSession]
GO


Create procedure [dbo].[A_Registrar_DropSession]
	@sessionid int = -1,
	@account nvarchar(100) = '',
	@callid nvarchar(200) = ''	
as
begin

	-- Удаляет сессию и контактные данные по указанной связке аккаунта, callid
	
	Declare @id int		
	Set @id = @sessionid

	-- Если сессия явно не указана - по CallId найдем
	if ( @id <= 0 ) begin	
	    Select @id = Id 
	    From A_RegistrarSession
	    Where ( CallId like @callid )
			and ( Account like @account )
	end

	-- Сессию чистим
	Delete 
	From A_RegistrarSession
	Where Id = @id
	
	-- Контакты дочищаем по отсутствию сессий
	Delete
	From A_RegistrarContact
	Where not exists ( Select Id From A_RegistrarSession s Where s.Id = A_RegistrarContact.SessionId )

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Registrar_DropAccount' ))
	Drop procedure [dbo].[A_Registrar_DropAccount]
GO


Create procedure [dbo].[A_Registrar_DropAccount]
	@account nvarchar(100) = ''	
as
begin
	
	-- Удаляет все сессии и контакты, соответствующие указанному аккаунту
	
	-- Сессии по аккаунту
	Delete 
	From A_RegistrarSession
	Where Account = @account
	
	-- Контакты дочищаем по отсутствию сессий
	Delete
	From A_RegistrarContact
	Where not exists ( Select Id From A_RegistrarSession s Where s.Id = A_RegistrarContact.SessionId )

end
GO
