﻿if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncTable' ))
	Drop procedure dbo.A_TaskManager_List_DirectDB_SyncTable
GO

Create procedure [dbo].[A_TaskManager_List_DirectDB_SyncTable]
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
	-- Производит синхронизацию кэша в БД с таблицей абонентов, заданной через таблицу на локальном сервере
	
	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	--set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	Declare @sql nvarchar ( 4000 )

	-- создаем таблицу для задачи, если ее нет еще, и наполняем значениями кэш, которых в нем нет
	exec A_TaskManager_List_DirectDB_CacheCreate
		@tableidx = @tableidx,
		@tableacindex = @tableacindex,
		@idfield = @idfield,
		@query = '',
		@table = @table
	


	-- обновляем на STATE = 3 удаленные из основной таблицы. (нужно только если количества не совпадают)
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where (State != 3)
				and not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = t.[Id] )'

	exec sp_sqlexec @sql
end
GO