﻿------- Поправка в: count(Distinct cast(m.IdUser as varchar(40))) as CountMembers
If Object_id('dbo.A_Chat_Dialog_GetTopX') Is not Null
    Drop procedure [dbo].[A_Chat_Dialog_GetTopX]
GO

Create procedure dbo.[A_Chat_Dialog_GetTopX]
	@authorizeduserid uniqueidentifier,
	@start int,
	@count int,
	@search1 nvarchar(1000) = '',
	@search2 nvarchar(1000) = ''
as
begin
		-- Достает диалоги по дате последнего сообщения с конца указанную пачку (по индексу, количество)
		
		if exists ( Select * FROM tempdb..sysobjects where id= object_id ( 'tempdb..#TopDialog' ))
			Drop table #TopDialog

		if exists ( Select * FROM tempdb..sysobjects where id= object_id ( 'tempdb..#DialogCountMembers' ))
			Drop table #DialogCountMembers
				
		if exists ( Select * FROM tempdb..sysobjects where id= object_id ( 'tempdb..#PrivateDialogOpponent' ))
			Drop table #PrivateDialogOpponent
		
		if exists ( Select * FROM tempdb..sysobjects where id= object_id ( 'tempdb..#FoundDialogs' ))
			Drop table #FoundDialogs

		Create table #TopDialog (IdDialog uniqueidentifier, Type int)
		Create table #DialogCountMembers (IdDialog uniqueidentifier, CountMembers int)
		Create table #PrivateDialogOpponent (IdDialog uniqueidentifier, PrivateIdUser uniqueidentifier)
		Create table #FoundDialogs (IdDialog uniqueidentifier)
		
		Declare @sql nvarchar(4000)
		Declare @rowcount int
		
		if (( @search1 = '' ) and ( @search2 = '' ))
		begin

			-- Нарезаем нужный интервал из сортированного по дате
			-- Сначала ограничение. Корректировка Count
			Select @rowcount = Count(*) 
			From dbo.[A_Chat_Dialog] dlg
			Where dlg.IdDialog in (	Select IdDialog 
									From dbo.[A_Chat_Members] 
									Where IdUser = @authorizeduserid )

			if ( @rowcount < @start + @count )
				Set @count = case when ( @rowcount - @start > 0 ) then @rowcount - @start else 0 end

			-- Потом выборка идентификаторов
			if ( @count > 0 ) begin
	
				Set @sql = 'Insert into #TopDialog ( IdDialog, Type )
					Select Top ' + Cast ( @count as nvarchar(10)) + ' IdDialog, Type
					From (
							Select Top ' + Cast ( @start + @count as nvarchar(10) ) + ' dlg.IdDialog, dlg.Type, dlg.LastDateUTC
							From dbo.[A_Chat_Dialog] dlg
							Where dlg.IdDialog in (	Select IdDialog 
													From dbo.[A_Chat_Members] 
													Where IdUser = @usr )
							Order by LastDateUTC desc ) a
					Order by LastDateUTC asc'

				Exec sp_executesql @sql, N'@usr uniqueidentifier', @usr = @authorizeduserid

			end
			
		end else begin
			
			if (( @search1 = '' ) or ( @search2 = '' )) begin

				Declare @search nvarchar(4000)
				if ( @search1 != '' )
					Set @search = @search1
				else
					Set @search = @search2

				-- Ищем диалоги с участием пользователя с фильтром по названию
				Insert into #FoundDialogs
					Select idDialog
					From 
					(
						Select	dlg.IdDialog
						From	dbo.[A_Chat_Dialog] dlg
						Where	dlg.IdDialog in ( Select IdDialog 
												  From dbo.[A_Chat_Members] 
												  Where IdUser = @authorizeduserid )
								and dlg.Type != 1
								and ( dlg.Name like '%'+@search1+'%' )
						
						Union all

						Select	dlg.IdDialog
						From	dbo.[A_Chat_Dialog] dlg 
									inner join dbo.[A_Chat_Members] m on m.IdDialog = dlg.IdDialog
									inner join dbo.A_Users users on m.IdUser = users.ID
						Where	dlg.IdDialog in ( Select IdDialog 
												  From dbo.[A_Chat_Members] 
												  Where IdUser = @authorizeduserid )
								and dlg.Type = 1
								and m.IdUser != @authorizeduserid
								and ( users.Name like '%'+@search+'%' )
					) a

			end else begin
			
				-- Ищем диалоги с участием пользователя с фильтром по названию
				Insert Into #FoundDialogs	
					Select IdDialog
					From 
					(
						Select	dlg.IdDialog
						From	dbo.[A_Chat_Dialog] dlg
						Where	dlg.IdDialog in ( Select IdDialog 
												  From dbo.[A_Chat_Members] 
												  Where IdUser = @authorizeduserid )
								and dlg.Type != 1
								and (( dlg.Name like '%'+@search1+'%' ) or ( dlg.Name like '%'+@search2+'%' ))

						Union all

						Select	dlg.IdDialog
						From	dbo.[A_Chat_Dialog] dlg 
									inner join dbo.[A_Chat_Members] m on ( m.IdDialog = dlg.IdDialog ) and ( m.IdUser != @authorizeduserid )
									inner join dbo.A_Users users on users.ID = m.IdUser
						Where	dlg.IdDialog in ( Select IdDialog 
												  From dbo.[A_Chat_Members] 
												  Where IdUser = @authorizeduserid)
								and dlg.Type = 1
								and (( users.Name like '%'+@search1+'%' ) or ( users.Name like '%'+@search2+'%' ))
					) a				
				
			end

			-- Нарезаем нужный интервал из сортированного по дате (уже по фильтру)
			-- Сначала ограничение. Корректировка Count
			Select @rowcount = Count(*) 
			From dbo.[A_Chat_Dialog] dlg
				Inner join #FoundDialogs f on f.IdDialog = dlg.IdDialog
	
			if ( @rowcount < @start + @count )
				Set @count = case when ( @rowcount - @start > 0 ) then @rowcount - @start else 0 end

			-- Потом выборка идентификаторов
			if ( @count > 0 ) begin

				Set @sql = 'Insert into #TopDialog ( IdDialog, Type )
					Select Top ' + Cast ( @count as nvarchar(10)) + ' IdDialog, Type
					From (
							Select Top ' + Cast ( @start + @count as nvarchar(10) ) + ' dlg.IdDialog, dlg.Type, dlg.LastDateUTC
							From dbo.[A_Chat_Dialog] dlg
								Inner join #FoundDialogs f on f.IdDialog = dlg.IdDialog
							Order by LastDateUTC desc ) a
					Order by LastDateUTC asc'

				Exec sp_executesql @sql

			end

		end

		
		-- Сохраняем количество участников
		Insert Into #DialogCountMembers ( IdDialog, CountMembers )
			Select	m.IdDialog,
				count(cast(m.IdUser as varchar(40))) as CountMembers
			From dbo.[A_Chat_Members] as m
			Where m.IdDialog in ( Select IdDialog From #TopDialog )
			Group by m.IdDialog
		

		-- Сохраняем оппонента приватных бесед
		Insert Into #PrivateDialogOpponent ( IdDialog, PrivateIdUser )
			Select	m.IdDialog,
					m.IdUser
			From dbo.[A_Chat_Members] as m
			Where m.IdDialog in ( Select IdDialog From #TopDialog Where [Type] = 1 )
				and m.IdUser != @authorizeduserid


		-- Итоговая выборка
		Select	dlg.IdDialog,
				dlg.Type,
				dlg.Name,
				dlg.God,
				dlg.LastDateUTC,					
				dlg.IdLinkedObject,
				m.IdMessage as LastMessageId,
				m.IdUser as LastUserId,
				u.Login as LastUserLogin,
				u.Name as LastUserName,
				m.DateUTC as LastMessageDTUTC,
				m.Text as LastMessageText,
				Case When ( m.IdUser = @authorizeduserid ) then	--'from me'
							Case When ((
											select	count(*)
											from	dbo.[A_Chat_NewMessages]
											where	IdMessage in (select LastIdMessage from #TopDialog) 
													and IdDialog = dlg.IdDialog
										)
											>=
										(
											select	count(*)
											from	dbo.[A_Chat_Members]
											where	IdDialog = dlg.IdDialog
													and IdUser != @authorizeduserid
										))
									Then 1 Else 0 
						End
					Else null
					End as FromMeIsNew,
				Case When ( m.IdUser != @authorizeduserid ) then --'for me'
							Case When ( Select count(*) 
										From dbo.[A_Chat_NewMessages] 
										Where IdMessage in ( Select LastIdMessage From #TopDialog ) 
												and IdDialog = dlg.IdDialog 
												and IdUser = @authorizeduserid ) = 0 
									Then 0 Else 1 
						End
					Else null
					End ForMeIsNew,
				dcm.CountMembers,
				pdo.PrivateIdUser
		From #TopDialog td 
				Inner join dbo.[A_Chat_Dialog] dlg on dlg.IdDialog = td.IdDialog
				Inner join #DialogCountMembers dcm on dcm.IdDialog = td.IdDialog
				Left join dbo.[A_Chat_Messages] m on m.IdMessage = dlg.LastIdMessage
				Left join #PrivateDialogOpponent pdo on pdo.IdDialog = td.IdDialog
				Left join dbo.A_Users u on u.Id = m.IdUser
		Order by dlg.LastDateUTC Desc

		
		drop table #DialogCountMembers
		drop table #TopDialog
		drop table #PrivateDialogOpponent
		drop table #FoundDialogs
		
end
GO