﻿IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Widgets_GetData_Procedure]'))
DROP PROCEDURE [dbo].[WO_Dashboards_Widgets_GetData_Procedure]
GO

CREATE procedure [dbo].[WO_Dashboards_Widgets_GetData_Procedure]
	@widgetidp	uniqueidentifier,
	@authorizedobjidp	uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
begin
	
	if (@authorizedobjidp = '00000000-0000-0000-0000-000000000000' or (@authorizedobjidp != '00000000-0000-0000-0000-000000000000' and (select count(*) from [dbo].[WO_Dashboards_Widgets] w inner join [dbo].[WO_Dashboards_Sections] s on w.IdSection = s.Id where w.Id = @widgetidp and s.IdDashboard = @authorizedobjidp) != 0))
		begin
			
			
			-- конструктор
			if ((select w.[Source] from [dbo].[WO_Dashboards_Widgets] w where w.Id = @widgetidp) = 0)
				begin
					
					--select	'конструктор'
					
					declare @widgetidn nvarchar(50)
					set @widgetidn = replace(cast(@widgetidp as nvarchar(50)), '-', '')
					
					
					
					declare	@droptables nvarchar(4000)
					set	@droptables = ''
					select	@droptables = @droptables + 'drop table ' + name + ' ' from tempdb.sys.tables where name like '##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP%'
					
					--select @droptables
					
					exec(@droptables)
					
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 1) != 0)
						begin
							--select	'есть "Cредняя скорость ответа (ASA)"'
							----------------------------------------------
							
							declare	@sqldesigner1 nvarchar(4000)
							
							declare	@constructorvalues nvarchar(4000)
							set	@constructorvalues = ''
							select	@constructorvalues = @constructorvalues +
								case
									when cv.ConstructorFunctionId = 1 then 'round(avg(lq.LenQueue), 0) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'round(sum(lq.LenQueue), 0) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'round(max(lq.LenQueue), 0) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'round(min(lq.LenQueue), 0) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 1
							) cv
							
							--select @constructorvalues
							
							declare	@constructorvalues1 nvarchar(4000)
							set	@constructorvalues1 = ''
							select	@constructorvalues1 = @constructorvalues1 +
								case
									when cv.ConstructorFunctionId = 1 then 'lq.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'lq.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'lq.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'lq.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 1
							) cv
							
							--select @constructorvalues1
							
							declare	@constructorfilters1 nvarchar(4000)
							set	@constructorfilters1 = 'and '
							select	@constructorfilters1 = @constructorfilters1 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(effconn_1.DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, effconn_1.DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, effconn_1.DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, effconn_1.DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, effconn_1.DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'cast(floor(cast(effconn_1.DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'cast(floor(cast(effconn_1.DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'cast(floor(cast(effconn_1.DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'cast(floor(cast(effconn_1.DateTimeStart as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'effconn_1.DateTimeStart'
										when cf.ConstructorFilterId = 2 then 'effconn_1.TimeStart'
										when cf.ConstructorFilterId = 3 then 'effconn_1.IdOperator'
										when cf.ConstructorFilterId = 4 then 'effconn_1.IdTask'
										when cf.ConstructorFilterId = 5 then 'effconn_1.IdProject'
										when cf.ConstructorFilterId = 7 then 'effconn_1.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, effconn_1.DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, effconn_1.DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, effconn_1.DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							
							--select @constructorfilters1
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner1 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 1
							
							--select @sqldesigner1
							
							-- в зависимости от оси добавляем столбец
							select @sqldesigner1 =
								case w.IdConstructorAxis
									when 1 then replace(@sqldesigner1, '_select_', 'convert(nvarchar(5), cast((floor(cast(effconn_2.TimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(effconn_2.TimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime)), 108) ' + da.Axis)
									when 2 then replace(@sqldesigner1, '_select_', 'convert(nvarchar(5), cast((floor(cast(effconn_2.TimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(effconn_2.TimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime)), 108) ' + da.Axis)
									when 3 then replace(@sqldesigner1, '_select_', 'convert(nvarchar(5), cast((floor(cast(effconn_2.TimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(effconn_2.TimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime)), 108) ' + da.Axis)
									when 4 then replace(@sqldesigner1, '_select_', 'convert(nvarchar(5), cast((floor(cast(effconn_2.TimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(effconn_2.TimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(effconn_2.TimeStart as float))) as datetime)), 108) ' + da.Axis)
									when 5 then replace(@sqldesigner1, '_select_', 'cast(datepart(yy, cast(floor(cast(effconn_2.DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(effconn_2.DateTimeStart as float)) as datetime), 10) ' + da.Axis)
									when 6 then replace(@sqldesigner1, '_select_', 'cast(datepart(yy, cast(floor(cast(effconn_2.DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(effconn_2.DateTimeStart as float) - datepart(dw, effconn_2.DateTimeStart) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(effconn_2.DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(effconn_2.DateTimeStart as float) - datepart(dw, effconn_2.DateTimeStart) + 1) as datetime)), 10) ' + da.Axis)
    								when 7 then replace(@sqldesigner1, '_select_', '
      													case datepart(mm, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime))
      														when 1 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      														when 2 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      														when 3 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      														when 4 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      														when 5 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      														when 6 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      														when 7 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      														when 8 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      														when 9 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      														when 10 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      														when 11 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      														when 12 then cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-'' + cast(datepart(mm, effconn_2.DateTimeStart) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      													end ' + da.Axis)
    								when 8 then replace(@sqldesigner1, '_select_', 'cast(datepart(yy, cast(cast(datepart(yy, effconn_2.DateTimeStart) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis)
    								when 9 then replace(@sqldesigner1, '_select_', 'effconn_1.IdOperator ')
    								when 10 then replace(@sqldesigner1, '_select_', 'effconn_1.IdTask ')
    								when 11 then replace(@sqldesigner1, '_select_', 'effconn_1.IdProject ')
    								when 12 then replace(@sqldesigner1, '_select_', '
    													case datepart(dw, effconn_2.DateTimeStart)
    														when 1 then ''1''
      														when 2 then ''2''
      														when 3 then ''3''
      														when 4 then ''4''
      														when 5 then ''5''
      														when 6 then ''6''
      														when 7 then ''7''
    													end ' + da.Axis)
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							--select @sqldesigner1
							
							-- в зависимости от оси добавляем прнивязку
							set @sqldesigner1 =
								case (select IdConstructorAxis from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									when 9 then replace(@sqldesigner1, '_join_', 'inner join (select IdChain, LenQueue, min(DateTimeStart) minDateTimeStart from [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] where IdOperator not in (''AB000000-0000-0000-0000-000000000000'', ''BF000000-0000-0000-0000-000000000000'', ''00000000-0000-0000-0000-000000000000'') and IdOperator is not null group by IdChain, LenQueue) effconn_3
																					on effconn_1.IdChain = effconn_3.IdChain and effconn_1.LenQueue = effconn_3.LenQueue and effconn_1.DateTimeStart = effconn_3.minDateTimeStart')
									else replace(@sqldesigner1, '_join_', '')
								end +
								case
									when @constructorfilters1 = 'and ' then ''
									else ' ' + (left(@constructorfilters1, len(@constructorfilters1)-len(' and ')))
								end
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner11 nvarchar(4000)
							select @sqldesigner11 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(lq.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues1, len(@constructorvalues1)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP1 from ('
									when 10 then 'select isnull(lq.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues1, len(@constructorvalues1)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP1 from ('
									when 11 then 'select isnull(lq.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues1, len(@constructorvalues1)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP1 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							declare	@sqldesigner12 nvarchar(4000)
							select @sqldesigner12 =
								case w.IdConstructorAxis
									when 1 then 'lq.' + da.Axis
									when 2 then 'lq.' + da.Axis
									when 3 then 'lq.' + da.Axis
									when 4 then 'lq.' + da.Axis
									when 5 then 'lq.' + da.Axis
									when 6 then 'lq.' + da.Axis
									when 7 then 'lq.' + da.Axis
									when 8 then 'lq.' + da.Axis
									when 9 then 'lq.IdOperator, oi.Name ' + da.Axis
									when 10 then 'lq.IdTask, t.Name ' + da.Axis
									when 11 then 'lq.IdProject, p.Name ' + da.Axis
									when 12 then 'lq.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							declare	@sqldesigner13 nvarchar(4000)
							select @sqldesigner13 = (left(@constructorvalues, len(@constructorvalues)-len(', ')))
							
							declare	@sqldesigner14_ nvarchar(4000)
							select @sqldesigner14_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP1'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							declare	@sqldesigner14 nvarchar(4000)
							select @sqldesigner14 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on lq.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on lq.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on lq.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							declare	@sqldesigner15 nvarchar(4000)
							select @sqldesigner15 =
								case w.IdConstructorAxis
									when 1 then 'lq.' + da.Axis
									when 2 then 'lq.' + da.Axis
									when 3 then 'lq.' + da.Axis
									when 4 then 'lq.' + da.Axis
									when 5 then 'lq.' + da.Axis
									when 6 then 'lq.' + da.Axis
									when 7 then 'lq.' + da.Axis
									when 8 then 'lq.' + da.Axis
									when 9 then 'lq.IdOperator, oi.Name'
									when 10 then 'lq.IdTask, t.Name'
									when 11 then 'lq.IdProject, p.Name'
									when 12 then 'lq.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							declare	@sqldesigner16 nvarchar(4000)
							select @sqldesigner16 =
								case w.IdConstructorAxis
									when 1 then ' order by lq.' + da.Axis + ' asc'
									when 2 then ' order by lq.' + da.Axis + ' asc'
									when 3 then ' order by lq.' + da.Axis + ' asc'
									when 4 then ' order by lq.' + da.Axis + ' asc'
									when 5 then ' order by lq.' + da.Axis + ' asc'
									when 6 then ' order by lq.' + da.Axis + ' asc'
									when 7 then ' order by lq.' + da.Axis + ' asc'
									when 8 then ' order by lq.' + da.Axis + ' asc'
									when 12 then ' order by lq.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							declare	@sqldesigner17 nvarchar(4000)
							select @sqldesigner17 =
								case w.IdConstructorAxis
									when 9 then ') lq'
									when 10 then ') lq'
									when 11 then ') lq'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
							declare	@sqldesigner18 nvarchar(4000)
							select @sqldesigner18 =
								case w.IdConstructorAxis
									when 9 then ' order by lq.' + da.Axis + ' asc'
									when 10 then ' order by lq.' + da.Axis + ' asc'
									when 11 then ' order by lq.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 1
							
																	
							exec('SET DATEFORMAT ymd SET DATEFIRST 1 ' + @sqldesigner11 + 'select ' + @sqldesigner12 + ', ' + @sqldesigner13 + @sqldesigner14_ + ' from (' + @sqldesigner1 + ') lq ' + @sqldesigner14 + 'group by ' + @sqldesigner15 + @sqldesigner16 + @sqldesigner17 + @sqldesigner18)
							
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 2) != 0)
						begin
							--select	'есть "Количество обслуженных вызовов по задачам"'
							---------------------------------------------------------
							
							declare	@sqldesigner2 nvarchar(4000)
							
							declare	@constructorfilters2 nvarchar(4000)
							set	@constructorfilters2 = 'and '
							select	@constructorfilters2 = @constructorfilters2 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'DateTimeStart'
										when cf.ConstructorFilterId = 2 then 'TimeStart'
										when cf.ConstructorFilterId = 3 then 'IdOperator'
										when cf.ConstructorFilterId = 4 then 'IdTask'
										when cf.ConstructorFilterId = 5 then 'IdProject'
										when cf.ConstructorFilterId = 7 then 'IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							
							--select @constructorfilters2
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner2 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 2
							
							--select @sqldesigner2
							
							-- в зависимости от оси добавляем столбец
							select @sqldesigner2 =
								case w.IdConstructorAxis
									when 1 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 2 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 3 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 4 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 5 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeStart as float)) as datetime), 10)')
									when 6 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 7, cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime)), 10)')
									when 7 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + '
														case datepart(mm, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime))
															when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
															when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
															when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
															when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
															when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
															when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
															when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
															when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
															when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
															when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
															when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
															when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
														end')
									when 8 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4))')
									when 9 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'cast(IdOperator as nvarchar(50))')
									when 10 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'cast(IdTask as nvarchar(50))')
									when 11 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + 'cast(IdProject as nvarchar(50))')
									when 12 then replace(@sqldesigner2, '_select_', da.Axis + ' = ' + '
														case datepart(dw, DateTimeStart)
															when 1 then ''1''
															when 2 then ''2''
															when 3 then ''3''
															when 4 then ''4''
															when 5 then ''5''
															when 6 then ''6''
															when 7 then ''7''
														end')
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							--select @sqldesigner2
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner21 nvarchar(4000)
							select @sqldesigner21 =
								case w.IdConstructorAxis
									when 1 then 'DateTimeStart datetime'
									when 2 then 'DateTimeStart datetime'
									when 3 then 'DateTimeStart datetime'
									when 4 then 'DateTimeStart datetime'
									when 5 then 'DateTimeStart datetime'
									when 6 then 'DateTimeStart datetime'
									when 7 then 'DateTimeStart datetime'
									when 8 then 'DateTimeStart datetime'
									when 9 then 'IdOperator uniqueidentifier'
									when 10 then 'IdTask uniqueidentifier'
									when 11 then 'IdProject uniqueidentifier'
									when 12 then 'DateTimeStart datetime'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner22 nvarchar(4000)
							select @sqldesigner22 =
								')
								declare @temp2 table (IdChain uniqueidentifier, Successful int, ' + da.Axis + ' nvarchar(50))
								declare @temp table (IdChain uniqueidentifier,  Successful int, ' + da.Axis + ' nvarchar(50))
								insert into @temp1
									select IdChain, CallResult, '
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner23 nvarchar(4000)
							select @sqldesigner23 =
								case w.IdConstructorAxis
									when 1 then 'DateTimeStart'
									when 2 then 'DateTimeStart'
									when 3 then 'DateTimeStart'
									when 4 then 'DateTimeStart'
									when 5 then 'DateTimeStart'
									when 6 then 'DateTimeStart'
									when 7 then 'DateTimeStart'
									when 8 then 'DateTimeStart'
									when 9 then 'IdOperator'
									when 10 then 'IdTask'
									when 11 then 'IdProject'
									when 12 then 'DateTimeStart'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner24 nvarchar(4000)
							select @sqldesigner24 =
								case
									when @constructorfilters2 = 'and ' then ''
									else ' ' + (left(@constructorfilters2, len(@constructorfilters2)-len(' and ')))
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner25 nvarchar(4000)
							select @sqldesigner25 =
								'
								insert into @temp
									select IdChain, Successful, ' + da.Axis + ' from @temp2'
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner26 nvarchar(4000)
							select @sqldesigner26 =
								case w.IdConstructorAxis
									when 9 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP2 from('
									when 10 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP2 from('
									when 11 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP2 from('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner27 nvarchar(4000)
							select @sqldesigner27 =
								'select temp.' + da.Axis + ', count(temp.Successful) ' + '[' + cf.Value + ',]'
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner28 nvarchar(4000)
							select @sqldesigner28 =
								case w.IdConstructorAxis
									when 9 then ', oi.Name from @temp temp '
									when 10 then ', t.Name from @temp temp '
									when 11 then ', p.Name from @temp temp '
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP2 from @temp temp '
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner29 nvarchar(4000)
							select @sqldesigner29 =
								case w.IdConstructorAxis
									when 9 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on temp.' + da.Axis + ' = oi.Id '
									when 10 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on temp.' + da.Axis + ' = t.Id '
									when 11 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on temp.' + da.Axis + ' = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner210 nvarchar(4000)
							select @sqldesigner210 =
								case w.IdConstructorAxis
									when 1 then 'temp.' + da.Axis
									when 2 then 'temp.' + da.Axis
									when 3 then 'temp.' + da.Axis
									when 4 then 'temp.' + da.Axis
									when 5 then 'temp.' + da.Axis
									when 6 then 'temp.' + da.Axis
									when 7 then 'temp.' + da.Axis
									when 8 then 'temp.' + da.Axis
									when 9 then 'temp.' + da.Axis + ', oi.Name'
									when 10 then 'temp.' + da.Axis + ', t.Name'
									when 11 then 'temp.' + da.Axis + ', p.Name'
									when 12 then 'temp.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner211 nvarchar(4000)
							select @sqldesigner211 =
								case w.IdConstructorAxis
									when 9 then ') oc'
									when 10 then ') oc'
									when 11 then ') oc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							declare	@sqldesigner212 nvarchar(4000)
							select @sqldesigner212 =
								case w.IdConstructorAxis
									when 1 then ' order by temp.' + da.Axis + ' asc'
									when 2 then ' order by temp.' + da.Axis + ' asc'
									when 3 then ' order by temp.' + da.Axis + ' asc'
									when 4 then ' order by temp.' + da.Axis + ' asc'
									when 5 then ' order by temp.' + da.Axis + ' asc'
									when 6 then ' order by temp.' + da.Axis + ' asc'
									when 7 then ' order by temp.' + da.Axis + ' asc'
									when 8 then ' order by temp.' + da.Axis + ' asc'
									when 9 then ' order by oc.Name asc'
									when 10 then ' order by oc.Name asc'
									when 11 then ' order by oc.Name asc'
									when 12 then ' order by temp.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 2
							
							
							exec('SET DATEFORMAT ymd SET DATEFIRST 1 declare @temp1 table (IdChain uniqueidentifier, CallResult int, ' + @sqldesigner21 + @sqldesigner22 + @sqldesigner23 + ' from [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] where IdChain is not null and IsOutput = 0 ' + @sqldesigner24 + ' ' + @sqldesigner2 + ' ' + @sqldesigner25 + ' ' + @sqldesigner26 + @sqldesigner27 + @sqldesigner28 + @sqldesigner29 + ' group by ' + @sqldesigner210 + @sqldesigner211 + @sqldesigner212)
							
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 3) != 0)
						begin
							--select	'есть "Количество потерянных вызовов по задачам"'
							---------------------------------------------------------
							
							declare	@sqldesigner3 nvarchar(4000)
							
							declare	@constructorfilters3 nvarchar(4000)
							set	@constructorfilters3 = 'and '
							select	@constructorfilters3 = @constructorfilters3 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'DateTimeStart'
										when cf.ConstructorFilterId = 2 then 'TimeStart'
										when cf.ConstructorFilterId = 3 then 'IdOperator'
										when cf.ConstructorFilterId = 4 then 'IdTask'
										when cf.ConstructorFilterId = 5 then 'IdProject'
										when cf.ConstructorFilterId = 7 then 'IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							
							--select @constructorfilters3
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner3 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 3
							
							--select @sqldesigner3
							
							-- в зависимости от оси добавляем столбец
							select @sqldesigner3 =
								case w.IdConstructorAxis
									when 1 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 2 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 3 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 4 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 5 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeStart as float)) as datetime), 10)')
									when 6 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 7, cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime)), 10)')
									when 7 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + '
														case datepart(mm, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime))
															when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
															when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
															when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
															when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
															when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
															when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
															when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
															when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
															when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
															when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
															when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
															when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
														end')
									when 8 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4))')
									when 9 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'cast(IdOperator as nvarchar(50))')
									when 10 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'cast(IdTask as nvarchar(50))')
									when 11 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + 'cast(IdProject as nvarchar(50))')
									when 12 then replace(@sqldesigner3, '_select_', da.Axis + ' = ' + '
														case datepart(dw, DateTimeStart)
															when 1 then ''1''
															when 2 then ''2''
															when 3 then ''3''
															when 4 then ''4''
															when 5 then ''5''
															when 6 then ''6''
															when 7 then ''7''
														end')
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							--select @sqldesigner3
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner31 nvarchar(4000)
							select @sqldesigner31 =
								case w.IdConstructorAxis
									when 1 then 'DateTimeStart datetime'
									when 2 then 'DateTimeStart datetime'
									when 3 then 'DateTimeStart datetime'
									when 4 then 'DateTimeStart datetime'
									when 5 then 'DateTimeStart datetime'
									when 6 then 'DateTimeStart datetime'
									when 7 then 'DateTimeStart datetime'
									when 8 then 'DateTimeStart datetime'
									when 9 then 'IdOperator uniqueidentifier'
									when 10 then 'IdTask uniqueidentifier'
									when 11 then 'IdProject uniqueidentifier'
									when 12 then 'DateTimeStart datetime'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner32 nvarchar(4000)
							select @sqldesigner32 =
								')
								declare @temp2 table (IdChain uniqueidentifier, UnSuccessful int, ' + da.Axis + ' nvarchar(50))
								declare @temp table (IdChain uniqueidentifier,  UnSuccessful int, ' + da.Axis + ' nvarchar(50))
								insert into @temp1
									select IdChain, CallResult, '
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner33 nvarchar(4000)
							select @sqldesigner33 =
								case w.IdConstructorAxis
									when 1 then 'DateTimeStart'
									when 2 then 'DateTimeStart'
									when 3 then 'DateTimeStart'
									when 4 then 'DateTimeStart'
									when 5 then 'DateTimeStart'
									when 6 then 'DateTimeStart'
									when 7 then 'DateTimeStart'
									when 8 then 'DateTimeStart'
									when 9 then 'IdOperator'
									when 10 then 'IdTask'
									when 11 then 'IdProject'
									when 12 then 'DateTimeStart'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner34 nvarchar(4000)
							select @sqldesigner34 =
								case
									when @constructorfilters3 = 'and ' then ''
									else ' ' + (left(@constructorfilters3, len(@constructorfilters3)-len(' and ')))
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner35 nvarchar(4000)
							select @sqldesigner35 =
								'
								insert into @temp
									select IdChain, UnSuccessful, ' + da.Axis + ' from @temp2'
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner36 nvarchar(4000)
							select @sqldesigner36 =
								case w.IdConstructorAxis
									when 9 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP3 from('
									when 10 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP3 from('
									when 11 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP3 from('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner37 nvarchar(4000)
							select @sqldesigner37 =
								'select temp.' + da.Axis + ', count(temp.UnSuccessful) ' + '[' + cf.Value + ',]'
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner38 nvarchar(4000)
							select @sqldesigner38 =
								case w.IdConstructorAxis
									when 9 then ', oi.Name from @temp temp '
									when 10 then ', t.Name from @temp temp '
									when 11 then ', p.Name from @temp temp '
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP3 from @temp temp '
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner39 nvarchar(4000)
							select @sqldesigner39 =
								case w.IdConstructorAxis
									when 9 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on temp.' + da.Axis + ' = oi.Id '
									when 10 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on temp.' + da.Axis + ' = t.Id '
									when 11 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on temp.' + da.Axis + ' = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner310 nvarchar(4000)
							select @sqldesigner310 =
								case w.IdConstructorAxis
									when 1 then 'temp.' + da.Axis
									when 2 then 'temp.' + da.Axis
									when 3 then 'temp.' + da.Axis
									when 4 then 'temp.' + da.Axis
									when 5 then 'temp.' + da.Axis
									when 6 then 'temp.' + da.Axis
									when 7 then 'temp.' + da.Axis
									when 8 then 'temp.' + da.Axis
									when 9 then 'temp.' + da.Axis + ', oi.Name'
									when 10 then 'temp.' + da.Axis + ', t.Name'
									when 11 then 'temp.' + da.Axis + ', p.Name'
									when 12 then 'temp.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner311 nvarchar(4000)
							select @sqldesigner311 =
								case w.IdConstructorAxis
									when 9 then ') oc'
									when 10 then ') oc'
									when 11 then ') oc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
							
							declare	@sqldesigner312 nvarchar(4000)
							select @sqldesigner312 =
								case w.IdConstructorAxis
									when 1 then ' order by temp.' + da.Axis + ' asc'
									when 2 then ' order by temp.' + da.Axis + ' asc'
									when 3 then ' order by temp.' + da.Axis + ' asc'
									when 4 then ' order by temp.' + da.Axis + ' asc'
									when 5 then ' order by temp.' + da.Axis + ' asc'
									when 6 then ' order by temp.' + da.Axis + ' asc'
									when 7 then ' order by temp.' + da.Axis + ' asc'
									when 8 then ' order by temp.' + da.Axis + ' asc'
									when 9 then ' order by oc.Name asc'
									when 10 then ' order by oc.Name asc'
									when 11 then ' order by oc.Name asc'
									when 12 then ' order by temp.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 3
												
							
							exec('SET DATEFORMAT ymd SET DATEFIRST 1 declare @temp1 table (IdChain uniqueidentifier, CallResult int, ' + @sqldesigner31 + @sqldesigner32 + @sqldesigner33 + ' from [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] where IdChain is not null and IsOutput = 0 ' + @sqldesigner34 + ' ' + @sqldesigner3 + ' ' + @sqldesigner35 + ' ' + @sqldesigner36 + @sqldesigner37 + @sqldesigner38 + @sqldesigner39 + ' group by ' + @sqldesigner310 + @sqldesigner311 + @sqldesigner312)
							
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 4) != 0)
						begin
							--select	'есть "Количество обслуженных и потерянных вызовов по задачам"'
							-----------------------------------------------------------------------
							
							declare	@sqldesigner4 nvarchar(4000)
							
							declare	@constructorfilters4 nvarchar(4000)
							set	@constructorfilters4 = 'and '
							select	@constructorfilters4 = @constructorfilters4 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, DateTimeStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'cast(floor(cast(DateTimeStart as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'DateTimeStart'
										when cf.ConstructorFilterId = 2 then 'TimeStart'
										when cf.ConstructorFilterId = 3 then 'IdOperator'
										when cf.ConstructorFilterId = 4 then 'IdTask'
										when cf.ConstructorFilterId = 5 then 'IdProject'
										when cf.ConstructorFilterId = 7 then 'IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, DateTimeStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							
							--select @constructorfilters4
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner4 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 4
							
							--select @sqldesigner4
							
							-- в зависимости от оси добавляем столбец
							select @sqldesigner4 =
								case w.IdConstructorAxis
									when 1 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 2 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 3 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 4 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)')
									when 5 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeStart as float)) as datetime), 10)')
									when 6 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 7, cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime)), 10)')
									when 7 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + '
														case datepart(mm, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime))
															when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
															when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
															when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
															when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
															when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
															when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
															when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
															when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
															when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
															when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
															when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
															when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + ''-'' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
														end')
									when 8 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4))')
									when 9 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'cast(IdOperator as nvarchar(50))')
									when 10 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'cast(IdTask as nvarchar(50))')
									when 11 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + 'cast(IdProject as nvarchar(50))')
									when 12 then replace(@sqldesigner4, '_select_', da.Axis + ' = ' + '
														case datepart(dw, DateTimeStart)
															when 1 then ''1''
															when 2 then ''2''
															when 3 then ''3''
															when 4 then ''4''
															when 5 then ''5''
															when 6 then ''6''
															when 7 then ''7''
														end')
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							--select @sqldesigner4
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner41 nvarchar(4000)
							select @sqldesigner41 =
								case w.IdConstructorAxis
									when 1 then 'DateTimeStart datetime'
									when 2 then 'DateTimeStart datetime'
									when 3 then 'DateTimeStart datetime'
									when 4 then 'DateTimeStart datetime'
									when 5 then 'DateTimeStart datetime'
									when 6 then 'DateTimeStart datetime'
									when 7 then 'DateTimeStart datetime'
									when 8 then 'DateTimeStart datetime'
									when 9 then 'IdOperator uniqueidentifier'
									when 10 then 'IdTask uniqueidentifier'
									when 11 then 'IdProject uniqueidentifier'
									when 12 then 'DateTimeStart datetime'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner42 nvarchar(4000)
							select @sqldesigner42 =
								')
								declare @temp2 table (IdChain uniqueidentifier, ' + da.Axis + ' nvarchar(50))
								declare @temp table (IdChain uniqueidentifier, ' + da.Axis + ' nvarchar(50))
								insert into @temp1
									select IdChain, CallResult, '
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner43 nvarchar(4000)
							select @sqldesigner43 =
								case w.IdConstructorAxis
									when 1 then 'DateTimeStart'
									when 2 then 'DateTimeStart'
									when 3 then 'DateTimeStart'
									when 4 then 'DateTimeStart'
									when 5 then 'DateTimeStart'
									when 6 then 'DateTimeStart'
									when 7 then 'DateTimeStart'
									when 8 then 'DateTimeStart'
									when 9 then 'IdOperator'
									when 10 then 'IdTask'
									when 11 then 'IdProject'
									when 12 then 'DateTimeStart'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner44 nvarchar(4000)
							select @sqldesigner44 =
								case
									when @constructorfilters4 = 'and ' then ''
									else ' ' + (left(@constructorfilters4, len(@constructorfilters4)-len(' and ')))
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner45 nvarchar(4000)
							select @sqldesigner45 =
								'
								insert into @temp
									select IdChain, ' + da.Axis + ' from @temp2'
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner46 nvarchar(4000)
							select @sqldesigner46 =
								case w.IdConstructorAxis
									when 9 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP4 from('
									when 10 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP4 from('
									when 11 then 'select oc.Name ' + da.Axis + ', oc.[' + cf.Value + ',] into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP4 from('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner47 nvarchar(4000)
							select @sqldesigner47 =
								'select temp.' + da.Axis + ', count(*) ' + '[' + cf.Value + ',]'
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner48 nvarchar(4000)
							select @sqldesigner48 =
								case w.IdConstructorAxis
									when 9 then ', oi.Name from @temp temp '
									when 10 then ', t.Name from @temp temp '
									when 11 then ', p.Name from @temp temp '
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP4 from @temp temp '
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner49 nvarchar(4000)
							select @sqldesigner49 =
								case w.IdConstructorAxis
									when 9 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on temp.' + da.Axis + ' = oi.Id '
									when 10 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on temp.' + da.Axis + ' = t.Id '
									when 11 then 'inner join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on temp.' + da.Axis + ' = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner410 nvarchar(4000)
							select @sqldesigner410 =
								case w.IdConstructorAxis
									when 1 then 'temp.' + da.Axis
									when 2 then 'temp.' + da.Axis
									when 3 then 'temp.' + da.Axis
									when 4 then 'temp.' + da.Axis
									when 5 then 'temp.' + da.Axis
									when 6 then 'temp.' + da.Axis
									when 7 then 'temp.' + da.Axis
									when 8 then 'temp.' + da.Axis
									when 9 then 'temp.' + da.Axis + ', oi.Name'
									when 10 then 'temp.' + da.Axis + ', t.Name'
									when 11 then 'temp.' + da.Axis + ', p.Name'
									when 12 then 'temp.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner411 nvarchar(4000)
							select @sqldesigner411 =
								case w.IdConstructorAxis
									when 9 then ') oc'
									when 10 then ') oc'
									when 11 then ') oc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							declare	@sqldesigner412 nvarchar(4000)
							select @sqldesigner412 =
								case w.IdConstructorAxis
									when 1 then ' order by temp.' + da.Axis + ' asc'
									when 2 then ' order by temp.' + da.Axis + ' asc'
									when 3 then ' order by temp.' + da.Axis + ' asc'
									when 4 then ' order by temp.' + da.Axis + ' asc'
									when 5 then ' order by temp.' + da.Axis + ' asc'
									when 6 then ' order by temp.' + da.Axis + ' asc'
									when 7 then ' order by temp.' + da.Axis + ' asc'
									when 8 then ' order by temp.' + da.Axis + ' asc'
									when 9 then ' order by oc.Name asc'
									when 10 then ' order by oc.Name asc'
									when 11 then ' order by oc.Name asc'
									when 12 then ' order by temp.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct cf.IdConstructorFields, cf.ConstructorValueId, dv.Value from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 4
							
							
							exec('SET DATEFORMAT ymd SET DATEFIRST 1 declare @temp1 table (IdChain uniqueidentifier, CallResult int, ' + @sqldesigner41 + @sqldesigner42 + @sqldesigner43 + ' from [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] where IdChain is not null and IsOutput = 0 ' + @sqldesigner44 + ' ' + @sqldesigner4 + ' ' + @sqldesigner45 + ' ' + @sqldesigner46 + @sqldesigner47 + @sqldesigner48 + @sqldesigner49 + ' group by ' + @sqldesigner410 + @sqldesigner411 + @sqldesigner412)
							
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 5) != 0)
						begin
							--select	'есть "Время операторов в состоянии готов"'
							---------------------------------------------------
							
							declare	@sqldesigner5 nvarchar(4000)
							
							declare	@constructorvalues5 nvarchar(4000)
							set	@constructorvalues5 = ''
							select	@constructorvalues5 = @constructorvalues5 +
								case
									when cv.ConstructorFunctionId = 1 then 'avg(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'sum(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'max(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'min(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 5
							) cv
							
							--select @constructorvalues5
							
							declare	@constructorvalues51 nvarchar(4000)
							set	@constructorvalues51 = ''
							select	@constructorvalues51 = @constructorvalues51 +
								case
									when cv.ConstructorFunctionId = 1 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 5
							) cv
							
							--select @constructorvalues51
							
							declare	@constructorfilters5 nvarchar(4000)
							set	@constructorfilters5 = 'and '
							select	@constructorfilters5 = @constructorfilters5 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'os.DateStart'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'os.DateTimeStart'
										--when cf.ConstructorFilterId = 2 then 'os.TimeStart'
										when cf.ConstructorFilterId = 3 then 'os.IdOperator'
										when cf.ConstructorFilterId = 4 then 'os.IdTask'
										when cf.ConstructorFilterId = 5 then 't.IdProject'
										when cf.ConstructorFilterId = 7 then '(os.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												--when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										--when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0 or os.IsOutput is null)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1 or os.IsOutput is null)'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							where	cf.ConstructorFilterId != 2
							
							--select @constructorfilters5
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner5 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 5
							
							--select @sqldesigner5
							
							-- добавляем отдельно фильтр по времени в шаблон
							if	(
									(
										select	count(*)
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
									) = 0
								)
								begin
									select @sqldesigner5 = replace(@sqldesigner5, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
								end
							else
								if	(
										(
											select	count(*)
											from
											(
												select	ConstructorFilterId,
														ConstructorFilterOperationId,
														ConstructorFilterValueId,
														ConstructorFilterValue1,
														ConstructorFilterValue2
												from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
												where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
											) cf
											where	cf.ConstructorFilterId = 2
										) = 0
									)
									begin
										select @sqldesigner5 = replace(@sqldesigner5, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
									end
								else
									begin
										select @sqldesigner5 = replace(@sqldesigner5, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000''')
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
										where	cf.ConstructorFilterId = 2
									end
							
							--select @sqldesigner5
							
							-- в зависимости от фильтров добавляем их
							set @sqldesigner5 =
								case
									when @constructorfilters5 = 'and ' then replace(@sqldesigner5, '_where_', '')
									else replace(@sqldesigner5, '_where_', ' ' + (left(@constructorfilters5, len(@constructorfilters5)-len(' and '))))
								end
							
							--select @sqldesigner5
							--exec(@sqldesigner5 + ' select distinct * from #temp5 order by IdOperator, DateTimeBegin drop table #temp5 ')
							
							-- в зависимости от оси добавляем столбец
							declare	@constructoraxis5 nvarchar(4000)
							set	@constructoraxis5 = ''
							select distinct	@constructoraxis5 = @constructoraxis5 +
								case w.IdConstructorAxis
									when 1 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 2 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 3 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 4 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 5 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float)) as datetime), 10) ' + da.Axis
									when 6 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime)), 10) ' + da.Axis
    								when 7 then '
      												case datepart(mm, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime))
      													when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      													when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      													when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      													when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      													when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      													when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      													when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      													when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      													when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      													when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      													when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      													when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      												end ' + da.Axis
    								when 8 then 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis
    								when 9 then 'IdOperator '
    								when 10 then 'IdTask '
    								when 11 then 'IdProject '
    								
    								when 12 then '
    												case datepart(dw, DateTimeBegin)
      													when 1 then ''1''
      													when 2 then ''2''
      													when 3 then ''3''
      													when 4 then ''4''
      													when 5 then ''5''
      													when 6 then ''6''
      													when 7 then ''7''
      												end ' + da.Axis
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							--select @constructoraxis5
							
							-- в зависимости от оси добавляем параметр, служащий для вычисления интервалов времени
							declare	@constructoraxisn5 nvarchar(4000)
							set	@constructoraxisn5 = 'declare @ni int set @ni = '
							select distinct	@constructoraxisn5 = @constructoraxisn5 +
								case w.IdConstructorAxis
									when 1 then '5'
									when 2 then '15'
									when 3 then '30'
									when 4 then '60'
									else '1440'
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							--select @constructoraxisn5
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner51 nvarchar(4000)
							select @sqldesigner51 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues51, len(@constructorvalues51)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP5 from ('
									when 10 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues51, len(@constructorvalues51)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP5 from ('
									when 11 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues51, len(@constructorvalues51)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP5 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							declare	@sqldesigner52 nvarchar(4000)
							select @sqldesigner52 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name ' + da.Axis
									when 10 then 'os.IdTask, t.Name ' + da.Axis
									when 11 then 'os.IdProject, p.Name ' + da.Axis
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							declare	@sqldesigner53 nvarchar(4000)
							select @sqldesigner53 = (left(@constructorvalues5, len(@constructorvalues5)-len(', ')))
							
							declare	@sqldesigner54_ nvarchar(4000)
							select @sqldesigner54_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP5'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							declare	@sqldesigner54_1 nvarchar(4000)
							select @sqldesigner54_1 =
							'
							select distinct n.State, n.DateTimeBegin, n.DateTimeEnd,
							cast(cast(
							(
								case when (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) > dateadd(mi, @ni, n.n) then dateadd(mi, @ni, n.n) else (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) end
									-
								case when (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) > n.n then (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) else n.n end
							)
							as float) * 86400 as int) LenTimeInterval,
							'
							
							declare	@sqldesigner54_2 nvarchar(4000)
							select @sqldesigner54_2 =
							'
							from
							(
								select t.*, dateadd(mi, n.n*@ni, @tm1) n from
								(
									select a1.n * 100 + a2.n * 10 + a3.n n from
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a1
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a2
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a3
								) n
								cross join #temp5 t
								where dateadd(mi, n.n*@ni, @tm1) between @tm1 and @tm2
							) n
							where n.n <= (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) and dateadd(mi, @ni, n.n) >= (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime))
							'
							
							declare	@sqldesigner54 nvarchar(4000)
							select @sqldesigner54 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on os.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on os.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on os.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							declare	@sqldesigner55 nvarchar(4000)
							select @sqldesigner55 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name'
									when 10 then 'os.IdTask, t.Name'
									when 11 then 'os.IdProject, p.Name'
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							declare	@sqldesigner56 nvarchar(4000)
							select @sqldesigner56 =
								case w.IdConstructorAxis
									when 1 then ' order by os.' + da.Axis + ' asc'
									when 2 then ' order by os.' + da.Axis + ' asc'
									when 3 then ' order by os.' + da.Axis + ' asc'
									when 4 then ' order by os.' + da.Axis + ' asc'
									when 5 then ' order by os.' + da.Axis + ' asc'
									when 6 then ' order by os.' + da.Axis + ' asc'
									when 7 then ' order by os.' + da.Axis + ' asc'
									when 8 then ' order by os.' + da.Axis + ' asc'
									when 12 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							declare	@sqldesigner57 nvarchar(4000)
							select @sqldesigner57 =
								case w.IdConstructorAxis
									when 9 then ') os'
									when 10 then ') os'
									when 11 then ') os'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							declare	@sqldesigner58 nvarchar(4000)
							select @sqldesigner58 =
								case w.IdConstructorAxis
									when 9 then ' order by os.' + da.Axis + ' asc'
									when 10 then ' order by os.' + da.Axis + ' asc'
									when 11 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 5
							
							
							--select @sqldesigner5 union all select ' ' union all select @constructoraxisn5 union all select ' ' union all select @sqldesigner51 union all select 'select ' union all select @sqldesigner52 union all select ', ' union all select @sqldesigner53 union all select @sqldesigner54_ union all select ' from (' + @sqldesigner54_1 union all select @constructoraxis5 union all select @sqldesigner54_2 union all select ') os ' union all select @sqldesigner54 union all select 'group by ' union all select @sqldesigner55 union all select @sqldesigner56 union all select @sqldesigner57 union all select @sqldesigner58 union all select ' drop table #temp5 '
							exec('SET DATEFORMAT ymd ' + @sqldesigner5 + ' ' + @constructoraxisn5 + ' ' + @sqldesigner51 + 'select ' + @sqldesigner52 + ', ' + @sqldesigner53 + @sqldesigner54_ + ' from (' + @sqldesigner54_1 + @constructoraxis5 + @sqldesigner54_2 + ') os ' + @sqldesigner54 + 'group by ' + @sqldesigner55 + @sqldesigner56 + @sqldesigner57 + @sqldesigner58 + ' drop table #temp5 ')
														
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 6) != 0)
						begin
							--select	'есть "Время операторов в перерыве"'
							--------------------------------------------
							
							declare	@sqldesigner6 nvarchar(4000)
							
							declare	@constructorvalues6 nvarchar(4000)
							set	@constructorvalues6 = ''
							select	@constructorvalues6 = @constructorvalues6 +
								case
									when cv.ConstructorFunctionId = 1 then 'avg(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'sum(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'max(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'min(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 6
							) cv
							
							--select @constructorvalues6
							
							declare	@constructorvalues61 nvarchar(4000)
							set	@constructorvalues61 = ''
							select	@constructorvalues61 = @constructorvalues61 +
								case
									when cv.ConstructorFunctionId = 1 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 6
							) cv
							
							--select @constructorvalues61
							
							declare	@constructorfilters6 nvarchar(4000)
							set	@constructorfilters6 = 'and '
							select	@constructorfilters6 = @constructorfilters6 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'os.DateStart'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'os.DateTimeStart'
										--when cf.ConstructorFilterId = 2 then 'os.TimeStart'
										when cf.ConstructorFilterId = 3 then 'os.IdOperator'
										when cf.ConstructorFilterId = 4 then 'os.IdTask'
										when cf.ConstructorFilterId = 5 then 't.IdProject'
										when cf.ConstructorFilterId = 7 then '(os.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												--when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										--when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0 or os.IsOutput is null)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1 or os.IsOutput is null)'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							where	cf.ConstructorFilterId != 2
							
							--select @constructorfilters6
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner6 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 6
							
							--select @sqldesigner6
							
							-- добавляем отдельно фильтр по времени в шаблон
							if	(
									(
										select	count(*)
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
									) = 0
								)
								begin
									select @sqldesigner6 = replace(@sqldesigner6, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
								end
							else
								if	(
										(
											select	count(*)
											from
											(
												select	ConstructorFilterId,
														ConstructorFilterOperationId,
														ConstructorFilterValueId,
														ConstructorFilterValue1,
														ConstructorFilterValue2
												from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
												where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
											) cf
											where	cf.ConstructorFilterId = 2
										) = 0
									)
									begin
										select @sqldesigner6 = replace(@sqldesigner6, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
									end
								else
									begin
										select @sqldesigner6 = replace(@sqldesigner6, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000''')
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
										where	cf.ConstructorFilterId = 2
									end
							
							--select @sqldesigner6
							
							-- в зависимости от фильтров добавляем их
							set @sqldesigner6 =
								case
									when @constructorfilters6 = 'and ' then replace(@sqldesigner6, '_where_', '')
									else replace(@sqldesigner6, '_where_', ' ' + (left(@constructorfilters6, len(@constructorfilters6)-len(' and '))))
								end
							
							--select @sqldesigner6
							--exec(@sqldesigner6 + ' select distinct * from #temp6 order by IdOperator, DateTimeBegin drop table #temp6 ')
							
							-- в зависимости от оси добавляем столбец
							declare	@constructoraxis6 nvarchar(4000)
							set	@constructoraxis6 = ''
							select distinct	@constructoraxis6 = @constructoraxis6 +
								case w.IdConstructorAxis
									when 1 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 2 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 3 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 4 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 5 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float)) as datetime), 10) ' + da.Axis
									when 6 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime)), 10) ' + da.Axis
    								when 7 then '
      												case datepart(mm, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime))
      													when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      													when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      													when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      													when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      													when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      													when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      													when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      													when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      													when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      													when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      													when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      													when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      												end ' + da.Axis
    								when 8 then 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis
    								when 9 then 'IdOperator '
    								when 10 then 'IdTask '
    								when 11 then 'IdProject '
    								
    								when 12 then '
    												case datepart(dw, DateTimeBegin)
      													when 1 then ''1''
      													when 2 then ''2''
      													when 3 then ''3''
      													when 4 then ''4''
      													when 5 then ''5''
      													when 6 then ''6''
      													when 7 then ''7''
      												end ' + da.Axis
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							--select @constructoraxis6
							
							-- в зависимости от оси добавляем параметр, служащий для вычисления интервалов времени
							declare	@constructoraxisn6 nvarchar(4000)
							set	@constructoraxisn6 = 'declare @ni int set @ni = '
							select distinct	@constructoraxisn6 = @constructoraxisn6 +
								case w.IdConstructorAxis
									when 1 then '5'
									when 2 then '15'
									when 3 then '30'
									when 4 then '60'
									else '1440'
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							--select @constructoraxisn6
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner61 nvarchar(4000)
							select @sqldesigner61 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues61, len(@constructorvalues61)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP6 from ('
									when 10 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues61, len(@constructorvalues61)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP6 from ('
									when 11 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues61, len(@constructorvalues61)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP6 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							declare	@sqldesigner62 nvarchar(4000)
							select @sqldesigner62 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name ' + da.Axis
									when 10 then 'os.IdTask, t.Name ' + da.Axis
									when 11 then 'os.IdProject, p.Name ' + da.Axis
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							declare	@sqldesigner63 nvarchar(4000)
							select @sqldesigner63 = (left(@constructorvalues6, len(@constructorvalues6)-len(', ')))
							
							declare	@sqldesigner64_ nvarchar(4000)
							select @sqldesigner64_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP6'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							declare	@sqldesigner64_1 nvarchar(4000)
							select @sqldesigner64_1 =
							'
							select distinct n.State, n.DateTimeBegin, n.DateTimeEnd,
							cast(cast(
							(
								case when (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) > dateadd(mi, @ni, n.n) then dateadd(mi, @ni, n.n) else (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) end
									-
								case when (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) > n.n then (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) else n.n end
							)
							as float) * 86400 as int) LenTimeInterval,
							'
							
							declare	@sqldesigner64_2 nvarchar(4000)
							select @sqldesigner64_2 =
							'
							from
							(
								select t.*, dateadd(mi, n.n*@ni, @tm1) n from
								(
									select a1.n * 100 + a2.n * 10 + a3.n n from
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a1
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a2
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a3
								) n
								cross join #temp6 t
								where dateadd(mi, n.n*@ni, @tm1) between @tm1 and @tm2
							) n
							where n.n <= (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) and dateadd(mi, @ni, n.n) >= (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime))
							'
							
							declare	@sqldesigner64 nvarchar(4000)
							select @sqldesigner64 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on os.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on os.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on os.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							declare	@sqldesigner65 nvarchar(4000)
							select @sqldesigner65 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name'
									when 10 then 'os.IdTask, t.Name'
									when 11 then 'os.IdProject, p.Name'
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							declare	@sqldesigner66 nvarchar(4000)
							select @sqldesigner66 =
								case w.IdConstructorAxis
									when 1 then ' order by os.' + da.Axis + ' asc'
									when 2 then ' order by os.' + da.Axis + ' asc'
									when 3 then ' order by os.' + da.Axis + ' asc'
									when 4 then ' order by os.' + da.Axis + ' asc'
									when 5 then ' order by os.' + da.Axis + ' asc'
									when 6 then ' order by os.' + da.Axis + ' asc'
									when 7 then ' order by os.' + da.Axis + ' asc'
									when 8 then ' order by os.' + da.Axis + ' asc'
									when 12 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							declare	@sqldesigner67 nvarchar(4000)
							select @sqldesigner67 =
								case w.IdConstructorAxis
									when 9 then ') os'
									when 10 then ') os'
									when 11 then ') os'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							declare	@sqldesigner68 nvarchar(4000)
							select @sqldesigner68 =
								case w.IdConstructorAxis
									when 9 then ' order by os.' + da.Axis + ' asc'
									when 10 then ' order by os.' + da.Axis + ' asc'
									when 11 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 6
							
							
							--select @sqldesigner6 union all select ' ' union all select @constructoraxisn6 union all select ' ' union all select @sqldesigner61 union all select 'select ' union all select @sqldesigner62 union all select ', ' union all select @sqldesigner63 union all select @sqldesigner64_ union all select ' from (' + @sqldesigner64_1 union all select @constructoraxis6 union all select @sqldesigner64_2 union all select ') os ' union all select @sqldesigner64 union all select 'group by ' union all select @sqldesigner65 union all select @sqldesigner66 union all select @sqldesigner67 union all select @sqldesigner68 union all select ' drop table #temp6 '
							exec('SET DATEFORMAT ymd ' + @sqldesigner6 + ' ' + @constructoraxisn6 + ' ' + @sqldesigner61 + 'select ' + @sqldesigner62 + ', ' + @sqldesigner63 + @sqldesigner64_ + ' from (' + @sqldesigner64_1 + @constructoraxis6 + @sqldesigner64_2 + ') os ' + @sqldesigner64 + 'group by ' + @sqldesigner65 + @sqldesigner66 + @sqldesigner67 + @sqldesigner68 + ' drop table #temp6 ')
														
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 7) != 0)
						begin
							--select	'есть "Время операторов в разговоре"'
							---------------------------------------------
							
							declare	@sqldesigner7 nvarchar(4000)
							
							declare	@constructorvalues7 nvarchar(4000)
							set	@constructorvalues7 = ''
							select	@constructorvalues7 = @constructorvalues7 +
								case
									when cv.ConstructorFunctionId = 1 then 'avg(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'sum(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'max(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'min(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 7
							) cv
							
							--select @constructorvalues7
							
							declare	@constructorvalues71 nvarchar(4000)
							set	@constructorvalues71 = ''
							select	@constructorvalues71 = @constructorvalues71 +
								case
									when cv.ConstructorFunctionId = 1 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 7
							) cv
							
							--select @constructorvalues71
							
							declare	@constructorfilters7 nvarchar(4000)
							set	@constructorfilters7 = 'and '
							select	@constructorfilters7 = @constructorfilters7 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'os.DateStart'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'os.DateTimeStart'
										--when cf.ConstructorFilterId = 2 then 'os.TimeStart'
										when cf.ConstructorFilterId = 3 then 'os.IdOperator'
										when cf.ConstructorFilterId = 4 then 'os.IdTask'
										when cf.ConstructorFilterId = 5 then 't.IdProject'
										when cf.ConstructorFilterId = 7 then 'os.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												--when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										--when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							where	cf.ConstructorFilterId != 2
							
							--select @constructorfilters7
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner7 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 7
							
							--select @sqldesigner7
							
							-- добавляем отдельно фильтр по времени в шаблон
							if	(
									(
										select	count(*)
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
									) = 0
								)
								begin
									select @sqldesigner7 = replace(@sqldesigner7, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
								end
							else
								if	(
										(
											select	count(*)
											from
											(
												select	ConstructorFilterId,
														ConstructorFilterOperationId,
														ConstructorFilterValueId,
														ConstructorFilterValue1,
														ConstructorFilterValue2
												from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
												where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
											) cf
											where	cf.ConstructorFilterId = 2
										) = 0
									)
									begin
										select @sqldesigner7 = replace(@sqldesigner7, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
									end
								else
									begin
										select @sqldesigner7 = replace(@sqldesigner7, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000''')
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
										where	cf.ConstructorFilterId = 2
									end
							
							--select @sqldesigner7
							
							-- в зависимости от фильтров добавляем их
							set @sqldesigner7 =
								case
									when @constructorfilters7 = 'and ' then replace(@sqldesigner7, '_where_', '')
									else replace(@sqldesigner7, '_where_', ' ' + (left(@constructorfilters7, len(@constructorfilters7)-len(' and '))))
								end
							
							--select @sqldesigner7
							--exec(@sqldesigner7 + ' select distinct * from #temp7 order by IdOperator, DateTimeBegin drop table #temp7 ')
							
							-- в зависимости от оси добавляем столбец
							declare	@constructoraxis7 nvarchar(4000)
							set	@constructoraxis7 = ''
							select distinct	@constructoraxis7 = @constructoraxis7 +
								case w.IdConstructorAxis
									when 1 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 2 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 3 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 4 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 5 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float)) as datetime), 10) ' + da.Axis
									when 6 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime)), 10) ' + da.Axis
    								when 7 then '
      												case datepart(mm, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime))
      													when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      													when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      													when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      													when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      													when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      													when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      													when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      													when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      													when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      													when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      													when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      													when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      												end ' + da.Axis
    								when 8 then 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis
    								when 9 then 'IdOperator '
    								when 10 then 'IdTask '
    								when 11 then 'IdProject '
    								
    								when 12 then '
    												case datepart(dw, DateTimeBegin)
      													when 1 then ''1''
      													when 2 then ''2''
      													when 3 then ''3''
      													when 4 then ''4''
      													when 5 then ''5''
      													when 6 then ''6''
      													when 7 then ''7''
      												end ' + da.Axis
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							--select @constructoraxis7
							
							-- в зависимости от оси добавляем параметр, служащий для вычисления интервалов времени
							declare	@constructoraxisn7 nvarchar(4000)
							set	@constructoraxisn7 = 'declare @ni int set @ni = '
							select distinct	@constructoraxisn7 = @constructoraxisn7 +
								case w.IdConstructorAxis
									when 1 then '5'
									when 2 then '15'
									when 3 then '30'
									when 4 then '60'
									else '1440'
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							--select @constructoraxisn7
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner71 nvarchar(4000)
							select @sqldesigner71 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues71, len(@constructorvalues71)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP7 from ('
									when 10 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues71, len(@constructorvalues71)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP7 from ('
									when 11 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues71, len(@constructorvalues71)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP7 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							declare	@sqldesigner72 nvarchar(4000)
							select @sqldesigner72 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name ' + da.Axis
									when 10 then 'os.IdTask, t.Name ' + da.Axis
									when 11 then 'os.IdProject, p.Name ' + da.Axis
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							declare	@sqldesigner73 nvarchar(4000)
							select @sqldesigner73 = (left(@constructorvalues7, len(@constructorvalues7)-len(', ')))
							
							declare	@sqldesigner74_ nvarchar(4000)
							select @sqldesigner74_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP7'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							declare	@sqldesigner74_1 nvarchar(4000)
							select @sqldesigner74_1 =
							'
							select distinct n.State, n.DateTimeBegin, n.DateTimeEnd,
							cast(cast(
							(
								case when (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) > dateadd(mi, @ni, n.n) then dateadd(mi, @ni, n.n) else (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) end
									-
								case when (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) > n.n then (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) else n.n end
							)
							as float) * 86400 as int) LenTimeInterval,
							'
							
							declare	@sqldesigner74_2 nvarchar(4000)
							select @sqldesigner74_2 =
							'
							from
							(
								select t.*, dateadd(mi, n.n*@ni, @tm1) n from
								(
									select a1.n * 100 + a2.n * 10 + a3.n n from
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a1
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a2
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a3
								) n
								cross join #temp7 t
								where dateadd(mi, n.n*@ni, @tm1) between @tm1 and @tm2
							) n
							where n.n <= (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) and dateadd(mi, @ni, n.n) >= (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime))
							'
							
							declare	@sqldesigner74 nvarchar(4000)
							select @sqldesigner74 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on os.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on os.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on os.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							declare	@sqldesigner75 nvarchar(4000)
							select @sqldesigner75 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name'
									when 10 then 'os.IdTask, t.Name'
									when 11 then 'os.IdProject, p.Name'
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							declare	@sqldesigner76 nvarchar(4000)
							select @sqldesigner76 =
								case w.IdConstructorAxis
									when 1 then ' order by os.' + da.Axis + ' asc'
									when 2 then ' order by os.' + da.Axis + ' asc'
									when 3 then ' order by os.' + da.Axis + ' asc'
									when 4 then ' order by os.' + da.Axis + ' asc'
									when 5 then ' order by os.' + da.Axis + ' asc'
									when 6 then ' order by os.' + da.Axis + ' asc'
									when 7 then ' order by os.' + da.Axis + ' asc'
									when 8 then ' order by os.' + da.Axis + ' asc'
									when 12 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							declare	@sqldesigner77 nvarchar(4000)
							select @sqldesigner77 =
								case w.IdConstructorAxis
									when 9 then ') os'
									when 10 then ') os'
									when 11 then ') os'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							declare	@sqldesigner78 nvarchar(4000)
							select @sqldesigner78 =
								case w.IdConstructorAxis
									when 9 then ' order by os.' + da.Axis + ' asc'
									when 10 then ' order by os.' + da.Axis + ' asc'
									when 11 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 7
							
							
							--select @sqldesigner7 union all select ' ' union all select @constructoraxisn7 union all select ' ' union all select @sqldesigner71 union all select 'select ' union all select @sqldesigner72 union all select ', ' union all select @sqldesigner73 union all select @sqldesigner74_ union all select ' from (' + @sqldesigner74_1 union all select @constructoraxis7 union all select @sqldesigner74_2 union all select ') os ' union all select @sqldesigner74 union all select 'group by ' union all select @sqldesigner75 union all select @sqldesigner76 union all select @sqldesigner77 union all select @sqldesigner78 union all select ' drop table #temp7 '
							exec('SET DATEFORMAT ymd ' + @sqldesigner7 + ' ' + @constructoraxisn7 + ' ' + @sqldesigner71 + 'select ' + @sqldesigner72 + ', ' + @sqldesigner73 + @sqldesigner74_ + ' from (' + @sqldesigner74_1 + @constructoraxis7 + @sqldesigner74_2 + ') os ' + @sqldesigner74 + 'group by ' + @sqldesigner75 + @sqldesigner76 + @sqldesigner77 + @sqldesigner78 + ' drop table #temp7 ')
														
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 8) != 0)
						begin
							--select	'есть "Время операторов в поствызывной обработке"'
							----------------------------------------------------------
							
							declare	@sqldesigner8 nvarchar(4000)
							
							declare	@constructorvalues8 nvarchar(4000)
							set	@constructorvalues8 = ''
							select	@constructorvalues8 = @constructorvalues8 +
								case
									when cv.ConstructorFunctionId = 1 then 'avg(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'sum(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'max(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'min(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 8
							) cv
							
							--select @constructorvalues8
							
							declare	@constructorvalues81 nvarchar(4000)
							set	@constructorvalues81 = ''
							select	@constructorvalues81 = @constructorvalues81 +
								case
									when cv.ConstructorFunctionId = 1 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 8
							) cv
							
							--select @constructorvalues81
							
							declare	@constructorfilters8 nvarchar(4000)
							set	@constructorfilters8 = 'and '
							select	@constructorfilters8 = @constructorfilters8 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'os.DateStart'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'os.DateTimeStart'
										--when cf.ConstructorFilterId = 2 then 'os.TimeStart'
										when cf.ConstructorFilterId = 3 then 'os.IdOperator'
										when cf.ConstructorFilterId = 4 then 'os.IdTask'
										when cf.ConstructorFilterId = 5 then 't.IdProject'
										when cf.ConstructorFilterId = 7 then 'os.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												--when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										--when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							where	cf.ConstructorFilterId != 2
							
							--select @constructorfilters8
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner8 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 8
							
							--select @sqldesigner8
							
							-- добавляем отдельно фильтр по времени в шаблон
							if	(
									(
										select	count(*)
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
									) = 0
								)
								begin
									select @sqldesigner8 = replace(@sqldesigner8, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
								end
							else
								if	(
										(
											select	count(*)
											from
											(
												select	ConstructorFilterId,
														ConstructorFilterOperationId,
														ConstructorFilterValueId,
														ConstructorFilterValue1,
														ConstructorFilterValue2
												from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
												where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
											) cf
											where	cf.ConstructorFilterId = 2
										) = 0
									)
									begin
										select @sqldesigner8 = replace(@sqldesigner8, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
									end
								else
									begin
										select @sqldesigner8 = replace(@sqldesigner8, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000''')
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
										where	cf.ConstructorFilterId = 2
									end
							
							--select @sqldesigner8
							
							-- в зависимости от фильтров добавляем их
							set @sqldesigner8 =
								case
									when @constructorfilters8 = 'and ' then replace(@sqldesigner8, '_where_', '')
									else replace(@sqldesigner8, '_where_', ' ' + (left(@constructorfilters8, len(@constructorfilters8)-len(' and '))))
								end
							
							--select @sqldesigner8
							--exec(@sqldesigner8 + ' select distinct * from #temp8 order by IdOperator, DateTimeBegin drop table #temp8 ')
							
							-- в зависимости от оси добавляем столбец
							declare	@constructoraxis8 nvarchar(4000)
							set	@constructoraxis8 = ''
							select distinct	@constructoraxis8 = @constructoraxis8 +
								case w.IdConstructorAxis
									when 1 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 2 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 3 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 4 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 5 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float)) as datetime), 10) ' + da.Axis
									when 6 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime)), 10) ' + da.Axis
    								when 7 then '
      												case datepart(mm, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime))
      													when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      													when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      													when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      													when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      													when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      													when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      													when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      													when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      													when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      													when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      													when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      													when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      												end ' + da.Axis
    								when 8 then 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis
    								when 9 then 'IdOperator '
    								when 10 then 'IdTask '
    								when 11 then 'IdProject '
    								
    								when 12 then '
    												case datepart(dw, DateTimeBegin)
      													when 1 then ''1''
      													when 2 then ''2''
      													when 3 then ''3''
      													when 4 then ''4''
      													when 5 then ''5''
      													when 6 then ''6''
      													when 7 then ''7''
      												end ' + da.Axis
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							--select @constructoraxis8
							
							-- в зависимости от оси добавляем параметр, служащий для вычисления интервалов времени
							declare	@constructoraxisn8 nvarchar(4000)
							set	@constructoraxisn8 = 'declare @ni int set @ni = '
							select distinct	@constructoraxisn8 = @constructoraxisn8 +
								case w.IdConstructorAxis
									when 1 then '5'
									when 2 then '15'
									when 3 then '30'
									when 4 then '60'
									else '1440'
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							--select @constructoraxisn8
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner81 nvarchar(4000)
							select @sqldesigner81 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues81, len(@constructorvalues81)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP8 from ('
									when 10 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues81, len(@constructorvalues81)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP8 from ('
									when 11 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues81, len(@constructorvalues81)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP8 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							declare	@sqldesigner82 nvarchar(4000)
							select @sqldesigner82 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name ' + da.Axis
									when 10 then 'os.IdTask, t.Name ' + da.Axis
									when 11 then 'os.IdProject, p.Name ' + da.Axis
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							declare	@sqldesigner83 nvarchar(4000)
							select @sqldesigner83 = (left(@constructorvalues8, len(@constructorvalues8)-len(', ')))
							
							declare	@sqldesigner84_ nvarchar(4000)
							select @sqldesigner84_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP8'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							declare	@sqldesigner84_1 nvarchar(4000)
							select @sqldesigner84_1 =
							'
							select distinct n.State, n.DateTimeBegin, n.DateTimeEnd,
							cast(cast(
							(
								case when (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) > dateadd(mi, @ni, n.n) then dateadd(mi, @ni, n.n) else (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) end
									-
								case when (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) > n.n then (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) else n.n end
							)
							as float) * 86400 as int) LenTimeInterval,
							'
							
							declare	@sqldesigner84_2 nvarchar(4000)
							select @sqldesigner84_2 =
							'
							from
							(
								select t.*, dateadd(mi, n.n*@ni, @tm1) n from
								(
									select a1.n * 100 + a2.n * 10 + a3.n n from
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a1
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a2
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a3
								) n
								cross join #temp8 t
								where dateadd(mi, n.n*@ni, @tm1) between @tm1 and @tm2
							) n
							where n.n <= (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) and dateadd(mi, @ni, n.n) >= (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime))
							'
							
							declare	@sqldesigner84 nvarchar(4000)
							select @sqldesigner84 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on os.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on os.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on os.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							declare	@sqldesigner85 nvarchar(4000)
							select @sqldesigner85 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name'
									when 10 then 'os.IdTask, t.Name'
									when 11 then 'os.IdProject, p.Name'
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							declare	@sqldesigner86 nvarchar(4000)
							select @sqldesigner86 =
								case w.IdConstructorAxis
									when 1 then ' order by os.' + da.Axis + ' asc'
									when 2 then ' order by os.' + da.Axis + ' asc'
									when 3 then ' order by os.' + da.Axis + ' asc'
									when 4 then ' order by os.' + da.Axis + ' asc'
									when 5 then ' order by os.' + da.Axis + ' asc'
									when 6 then ' order by os.' + da.Axis + ' asc'
									when 7 then ' order by os.' + da.Axis + ' asc'
									when 8 then ' order by os.' + da.Axis + ' asc'
									when 12 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							declare	@sqldesigner87 nvarchar(4000)
							select @sqldesigner87 =
								case w.IdConstructorAxis
									when 9 then ') os'
									when 10 then ') os'
									when 11 then ') os'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							declare	@sqldesigner88 nvarchar(4000)
							select @sqldesigner88 =
								case w.IdConstructorAxis
									when 9 then ' order by os.' + da.Axis + ' asc'
									when 10 then ' order by os.' + da.Axis + ' asc'
									when 11 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 8
							
							
							--select @sqldesigner8 union all select ' ' union all select @constructoraxisn8 union all select ' ' union all select @sqldesigner81 union all select 'select ' union all select @sqldesigner82 union all select ', ' union all select @sqldesigner83 union all select @sqldesigner84_ union all select ' from (' + @sqldesigner84_1 union all select @constructoraxis8 union all select @sqldesigner84_2 union all select ') os ' union all select @sqldesigner84 union all select 'group by ' union all select @sqldesigner85 union all select @sqldesigner86 union all select @sqldesigner87 union all select @sqldesigner88 union all select ' drop table #temp8 '
							exec('SET DATEFORMAT ymd ' + @sqldesigner8 + ' ' + @constructoraxisn8 + ' ' + @sqldesigner81 + 'select ' + @sqldesigner82 + ', ' + @sqldesigner83 + @sqldesigner84_ + ' from (' + @sqldesigner84_1 + @constructoraxis8 + @sqldesigner84_2 + ') os ' + @sqldesigner84 + 'group by ' + @sqldesigner85 + @sqldesigner86 + @sqldesigner87 + @sqldesigner88 + ' drop table #temp8 ')
														
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 9) != 0)
						begin
							--select	'есть "Время операторов в ожидании ответа абонента"'
							------------------------------------------------------------
							
							declare	@sqldesigner9 nvarchar(4000)
							
							declare	@constructorvalues9 nvarchar(4000)
							set	@constructorvalues9 = ''
							select	@constructorvalues9 = @constructorvalues9 +
								case
									when cv.ConstructorFunctionId = 1 then 'avg(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'sum(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'max(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'min(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 9
							) cv
							
							--select @constructorvalues9
							
							declare	@constructorvalues91 nvarchar(4000)
							set	@constructorvalues91 = ''
							select	@constructorvalues91 = @constructorvalues91 +
								case
									when cv.ConstructorFunctionId = 1 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 9
							) cv
							
							--select @constructorvalues91
							
							declare	@constructorfilters9 nvarchar(4000)
							set	@constructorfilters9 = 'and '
							select	@constructorfilters9 = @constructorfilters9 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'os.DateStart'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'os.DateTimeStart'
										--when cf.ConstructorFilterId = 2 then 'os.TimeStart'
										when cf.ConstructorFilterId = 3 then 'os.IdOperator'
										when cf.ConstructorFilterId = 4 then 'os.IdTask'
										when cf.ConstructorFilterId = 5 then 't.IdProject'
										when cf.ConstructorFilterId = 7 then 'os.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												--when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										--when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							where	cf.ConstructorFilterId != 2
							
							--select @constructorfilters9
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner9 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 9
							
							--select @sqldesigner9
							
							-- добавляем отдельно фильтр по времени в шаблон
							if	(
									(
										select	count(*)
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
									) = 0
								)
								begin
									select @sqldesigner9 = replace(@sqldesigner9, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
								end
							else
								if	(
										(
											select	count(*)
											from
											(
												select	ConstructorFilterId,
														ConstructorFilterOperationId,
														ConstructorFilterValueId,
														ConstructorFilterValue1,
														ConstructorFilterValue2
												from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
												where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
											) cf
											where	cf.ConstructorFilterId = 2
										) = 0
									)
									begin
										select @sqldesigner9 = replace(@sqldesigner9, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
									end
								else
									begin
										select @sqldesigner9 = replace(@sqldesigner9, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000''')
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
										where	cf.ConstructorFilterId = 2
									end
							
							--select @sqldesigner9
							
							-- в зависимости от фильтров добавляем их
							set @sqldesigner9 =
								case
									when @constructorfilters9 = 'and ' then replace(@sqldesigner9, '_where_', '')
									else replace(@sqldesigner9, '_where_', ' ' + (left(@constructorfilters9, len(@constructorfilters9)-len(' and '))))
								end
							
							--select @sqldesigner9
							--exec(@sqldesigner9 + ' select distinct * from #temp9 order by IdOperator, DateTimeBegin drop table #temp9 ')
							
							-- в зависимости от оси добавляем столбец
							declare	@constructoraxis9 nvarchar(4000)
							set	@constructoraxis9 = ''
							select distinct	@constructoraxis9 = @constructoraxis9 +
								case w.IdConstructorAxis
									when 1 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 2 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 3 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 4 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 5 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float)) as datetime), 10) ' + da.Axis
									when 6 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime)), 10) ' + da.Axis
    								when 7 then '
      												case datepart(mm, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime))
      													when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      													when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      													when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      													when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      													when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      													when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      													when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      													when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      													when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      													when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      													when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      													when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      												end ' + da.Axis
    								when 8 then 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis
    								when 9 then 'IdOperator '
    								when 10 then 'IdTask '
    								when 11 then 'IdProject '
    								
    								when 12 then '
    												case datepart(dw, DateTimeBegin)
      													when 1 then ''1''
      													when 2 then ''2''
      													when 3 then ''3''
      													when 4 then ''4''
      													when 5 then ''5''
      													when 6 then ''6''
      													when 7 then ''7''
      												end ' + da.Axis
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							--select @constructoraxis9
							
							-- в зависимости от оси добавляем параметр, служащий для вычисления интервалов времени
							declare	@constructoraxisn9 nvarchar(4000)
							set	@constructoraxisn9 = 'declare @ni int set @ni = '
							select distinct	@constructoraxisn9 = @constructoraxisn9 +
								case w.IdConstructorAxis
									when 1 then '5'
									when 2 then '15'
									when 3 then '30'
									when 4 then '60'
									else '1440'
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							--select @constructoraxisn9
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner91 nvarchar(4000)
							select @sqldesigner91 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues91, len(@constructorvalues91)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP9 from ('
									when 10 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues91, len(@constructorvalues91)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP9 from ('
									when 11 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues91, len(@constructorvalues91)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP9 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							declare	@sqldesigner92 nvarchar(4000)
							select @sqldesigner92 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name ' + da.Axis
									when 10 then 'os.IdTask, t.Name ' + da.Axis
									when 11 then 'os.IdProject, p.Name ' + da.Axis
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							declare	@sqldesigner93 nvarchar(4000)
							select @sqldesigner93 = (left(@constructorvalues9, len(@constructorvalues9)-len(', ')))
							
							declare	@sqldesigner94_ nvarchar(4000)
							select @sqldesigner94_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP9'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							declare	@sqldesigner94_1 nvarchar(4000)
							select @sqldesigner94_1 =
							'
							select distinct n.State, n.DateTimeBegin, n.DateTimeEnd,
							cast(cast(
							(
								case when (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) > dateadd(mi, @ni, n.n) then dateadd(mi, @ni, n.n) else (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) end
									-
								case when (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) > n.n then (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) else n.n end
							)
							as float) * 86400 as int) LenTimeInterval,
							'
							
							declare	@sqldesigner94_2 nvarchar(4000)
							select @sqldesigner94_2 =
							'
							from
							(
								select t.*, dateadd(mi, n.n*@ni, @tm1) n from
								(
									select a1.n * 100 + a2.n * 10 + a3.n n from
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a1
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a2
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a3
								) n
								cross join #temp9 t
								where dateadd(mi, n.n*@ni, @tm1) between @tm1 and @tm2
							) n
							where n.n <= (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) and dateadd(mi, @ni, n.n) >= (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime))
							'
							
							declare	@sqldesigner94 nvarchar(4000)
							select @sqldesigner94 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on os.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on os.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on os.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							declare	@sqldesigner95 nvarchar(4000)
							select @sqldesigner95 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name'
									when 10 then 'os.IdTask, t.Name'
									when 11 then 'os.IdProject, p.Name'
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							declare	@sqldesigner96 nvarchar(4000)
							select @sqldesigner96 =
								case w.IdConstructorAxis
									when 1 then ' order by os.' + da.Axis + ' asc'
									when 2 then ' order by os.' + da.Axis + ' asc'
									when 3 then ' order by os.' + da.Axis + ' asc'
									when 4 then ' order by os.' + da.Axis + ' asc'
									when 5 then ' order by os.' + da.Axis + ' asc'
									when 6 then ' order by os.' + da.Axis + ' asc'
									when 7 then ' order by os.' + da.Axis + ' asc'
									when 8 then ' order by os.' + da.Axis + ' asc'
									when 12 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							declare	@sqldesigner97 nvarchar(4000)
							select @sqldesigner97 =
								case w.IdConstructorAxis
									when 9 then ') os'
									when 10 then ') os'
									when 11 then ') os'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							declare	@sqldesigner98 nvarchar(4000)
							select @sqldesigner98 =
								case w.IdConstructorAxis
									when 9 then ' order by os.' + da.Axis + ' asc'
									when 10 then ' order by os.' + da.Axis + ' asc'
									when 11 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 9
							
							
							--select @sqldesigner9 union all select ' ' union all select @constructoraxisn9 union all select ' ' union all select @sqldesigner91 union all select 'select ' union all select @sqldesigner92 union all select ', ' union all select @sqldesigner93 union all select @sqldesigner94_ union all select ' from (' + @sqldesigner94_1 union all select @constructoraxis9 union all select @sqldesigner94_2 union all select ') os ' union all select @sqldesigner94 union all select 'group by ' union all select @sqldesigner95 union all select @sqldesigner96 union all select @sqldesigner97 union all select @sqldesigner98 union all select ' drop table #temp9 '
							exec('SET DATEFORMAT ymd ' + @sqldesigner9 + ' ' + @constructoraxisn9 + ' ' + @sqldesigner91 + 'select ' + @sqldesigner92 + ', ' + @sqldesigner93 + @sqldesigner94_ + ' from (' + @sqldesigner94_1 + @constructoraxis9 + @sqldesigner94_2 + ') os ' + @sqldesigner94 + 'group by ' + @sqldesigner95 + @sqldesigner96 + @sqldesigner97 + @sqldesigner98 + ' drop table #temp9 ')
														
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 10) != 0)
						begin
							--select	'есть "Время операторов в предварительной обработке"'
							-------------------------------------------------------------
							
							declare	@sqldesigner10 nvarchar(4000)
							
							declare	@constructorvalues10 nvarchar(4000)
							set	@constructorvalues10 = ''
							select	@constructorvalues10 = @constructorvalues10 +
								case
									when cv.ConstructorFunctionId = 1 then 'avg(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'sum(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'max(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'min(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 10
							) cv
							
							--select @constructorvalues10
							
							declare	@constructorvalues101 nvarchar(4000)
							set	@constructorvalues101 = ''
							select	@constructorvalues101 = @constructorvalues101 +
								case
									when cv.ConstructorFunctionId = 1 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 10
							) cv
							
							--select @constructorvalues101
							
							declare	@constructorfilters10 nvarchar(4000)
							set	@constructorfilters10 = 'and '
							select	@constructorfilters10 = @constructorfilters10 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'os.DateStart'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'os.DateTimeStart'
										--when cf.ConstructorFilterId = 2 then 'os.TimeStart'
										when cf.ConstructorFilterId = 3 then 'os.IdOperator'
										when cf.ConstructorFilterId = 4 then 'os.IdTask'
										when cf.ConstructorFilterId = 5 then 't.IdProject'
										when cf.ConstructorFilterId = 7 then 'os.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												--when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										--when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							where	cf.ConstructorFilterId != 2
							
							--select @constructorfilters10
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner10 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 10
							
							--select @sqldesigner10
							
							-- добавляем отдельно фильтр по времени в шаблон
							if	(
									(
										select	count(*)
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
									) = 0
								)
								begin
									select @sqldesigner10 = replace(@sqldesigner10, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
								end
							else
								if	(
										(
											select	count(*)
											from
											(
												select	ConstructorFilterId,
														ConstructorFilterOperationId,
														ConstructorFilterValueId,
														ConstructorFilterValue1,
														ConstructorFilterValue2
												from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
												where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
											) cf
											where	cf.ConstructorFilterId = 2
										) = 0
									)
									begin
										select @sqldesigner10 = replace(@sqldesigner10, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
									end
								else
									begin
										select @sqldesigner10 = replace(@sqldesigner10, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000''')
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
										where	cf.ConstructorFilterId = 2
									end
							
							--select @sqldesigner10
							
							-- в зависимости от фильтров добавляем их
							set @sqldesigner10 =
								case
									when @constructorfilters10 = 'and ' then replace(@sqldesigner10, '_where_', '')
									else replace(@sqldesigner10, '_where_', ' ' + (left(@constructorfilters10, len(@constructorfilters10)-len(' and '))))
								end
							
							--select @sqldesigner10
							--exec(@sqldesigner10 + ' select distinct * from #temp10 order by IdOperator, DateTimeBegin drop table #temp10 ')
							
							-- в зависимости от оси добавляем столбец
							declare	@constructoraxis10 nvarchar(4000)
							set	@constructoraxis10 = ''
							select distinct	@constructoraxis10 = @constructoraxis10 +
								case w.IdConstructorAxis
									when 1 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 2 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 3 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 4 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 5 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float)) as datetime), 10) ' + da.Axis
									when 6 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime)), 10) ' + da.Axis
    								when 7 then '
      												case datepart(mm, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime))
      													when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      													when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      													when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      													when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      													when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      													when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      													when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      													when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      													when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      													when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      													when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      													when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      												end ' + da.Axis
    								when 8 then 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis
    								when 9 then 'IdOperator '
    								when 10 then 'IdTask '
    								when 11 then 'IdProject '
    								
    								when 12 then '
    												case datepart(dw, DateTimeBegin)
      													when 1 then ''1''
      													when 2 then ''2''
      													when 3 then ''3''
      													when 4 then ''4''
      													when 5 then ''5''
      													when 6 then ''6''
      													when 7 then ''7''
      												end ' + da.Axis
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							--select @constructoraxis10
							
							-- в зависимости от оси добавляем параметр, служащий для вычисления интервалов времени
							declare	@constructoraxisn10 nvarchar(4000)
							set	@constructoraxisn10 = 'declare @ni int set @ni = '
							select distinct	@constructoraxisn10 = @constructoraxisn10 +
								case w.IdConstructorAxis
									when 1 then '5'
									when 2 then '15'
									when 3 then '30'
									when 4 then '60'
									else '1440'
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							--select @constructoraxisn10
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner101 nvarchar(4000)
							select @sqldesigner101 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues101, len(@constructorvalues101)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP10 from ('
									when 10 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues101, len(@constructorvalues101)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP10 from ('
									when 11 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues101, len(@constructorvalues101)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP10 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							declare	@sqldesigner102 nvarchar(4000)
							select @sqldesigner102 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name ' + da.Axis
									when 10 then 'os.IdTask, t.Name ' + da.Axis
									when 11 then 'os.IdProject, p.Name ' + da.Axis
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							declare	@sqldesigner103 nvarchar(4000)
							select @sqldesigner103 = (left(@constructorvalues10, len(@constructorvalues10)-len(', ')))
							
							declare	@sqldesigner104_ nvarchar(4000)
							select @sqldesigner104_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP10'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							declare	@sqldesigner104_1 nvarchar(4000)
							select @sqldesigner104_1 =
							'
							select distinct n.State, n.DateTimeBegin, n.DateTimeEnd,
							cast(cast(
							(
								case when (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) > dateadd(mi, @ni, n.n) then dateadd(mi, @ni, n.n) else (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) end
									-
								case when (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) > n.n then (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) else n.n end
							)
							as float) * 86400 as int) LenTimeInterval,
							'
							
							declare	@sqldesigner104_2 nvarchar(4000)
							select @sqldesigner104_2 =
							'
							from
							(
								select t.*, dateadd(mi, n.n*@ni, @tm1) n from
								(
									select a1.n * 100 + a2.n * 10 + a3.n n from
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a1
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a2
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a3
								) n
								cross join #temp10 t
								where dateadd(mi, n.n*@ni, @tm1) between @tm1 and @tm2
							) n
							where n.n <= (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) and dateadd(mi, @ni, n.n) >= (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime))
							'
							
							declare	@sqldesigner104 nvarchar(4000)
							select @sqldesigner104 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on os.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on os.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on os.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							declare	@sqldesigner105 nvarchar(4000)
							select @sqldesigner105 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name'
									when 10 then 'os.IdTask, t.Name'
									when 11 then 'os.IdProject, p.Name'
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							declare	@sqldesigner106 nvarchar(4000)
							select @sqldesigner106 =
								case w.IdConstructorAxis
									when 1 then ' order by os.' + da.Axis + ' asc'
									when 2 then ' order by os.' + da.Axis + ' asc'
									when 3 then ' order by os.' + da.Axis + ' asc'
									when 4 then ' order by os.' + da.Axis + ' asc'
									when 5 then ' order by os.' + da.Axis + ' asc'
									when 6 then ' order by os.' + da.Axis + ' asc'
									when 7 then ' order by os.' + da.Axis + ' asc'
									when 8 then ' order by os.' + da.Axis + ' asc'
									when 12 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							declare	@sqldesigner107 nvarchar(4000)
							select @sqldesigner107 =
								case w.IdConstructorAxis
									when 9 then ') os'
									when 10 then ') os'
									when 11 then ') os'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							declare	@sqldesigner108 nvarchar(4000)
							select @sqldesigner108 =
								case w.IdConstructorAxis
									when 9 then ' order by os.' + da.Axis + ' asc'
									when 10 then ' order by os.' + da.Axis + ' asc'
									when 11 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 10
							
							
							--select @sqldesigner10 union all select ' ' union all select @constructoraxisn10 union all select ' ' union all select @sqldesigner101 union all select 'select ' union all select @sqldesigner102 union all select ', ' union all select @sqldesigner103 union all select @sqldesigner104_ union all select ' from (' + @sqldesigner104_1 union all select @constructoraxis10 union all select @sqldesigner104_2 union all select ') os ' union all select @sqldesigner104 union all select 'group by ' union all select @sqldesigner105 union all select @sqldesigner106 union all select @sqldesigner107 union all select @sqldesigner108 union all select ' drop table #temp10 '
							exec('SET DATEFORMAT ymd ' + @sqldesigner10 + ' ' + @constructoraxisn10 + ' ' + @sqldesigner101 + 'select ' + @sqldesigner102 + ', ' + @sqldesigner103 + @sqldesigner104_ + ' from (' + @sqldesigner104_1 + @constructoraxis10 + @sqldesigner104_2 + ') os ' + @sqldesigner104 + 'group by ' + @sqldesigner105 + @sqldesigner106 + @sqldesigner107 + @sqldesigner108 + ' drop table #temp10 ')
														
						end
					
					
					if ((select count(*) from [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf where cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp) and cf.ConstructorValueId = 11) != 0)
						begin
							--select	'есть "Время операторов в обратном вызове"'
							---------------------------------------------------
							
							declare	@sqldesigner011 nvarchar(4000)
							
							declare	@constructorvalues011 nvarchar(4000)
							set	@constructorvalues011 = ''
							select	@constructorvalues011 = @constructorvalues011 +
								case
									when cv.ConstructorFunctionId = 1 then 'avg(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'sum(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'max(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'min(os.LenTimeInterval) [' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											left join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 11
							) cv
							
							--select @constructorvalues011
							
							declare	@constructorvalues0111 nvarchar(4000)
							set	@constructorvalues0111 = ''
							select	@constructorvalues0111 = @constructorvalues0111 +
								case
									when cv.ConstructorFunctionId = 1 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 2 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 3 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
									when cv.ConstructorFunctionId = 4 then 'os.[' + cv.Value + ',' + cv.[Function] + '], '
								end
							from
							(
								select	cf.ConstructorValueId,
										dv.Value,
										cf.ConstructorFunctionId,
										df.[Function],
										df.FunctionText
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf
											inner join [dbo].[WO_Dashboards_Widgets_Designer_Function] df on cf.ConstructorFunctionId = df.Id
												inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dv on cf.ConstructorValueId = dv.Id
								where	cf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										and cf.ConstructorValueId = 11
							) cv
							
							--select @constructorvalues0111
							
							declare	@constructorfilters011 nvarchar(4000)
							set	@constructorfilters011 = 'and '
							select	@constructorfilters011 = @constructorfilters011 +
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, os.DateStart)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'os.DateStart'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'os.DateStart'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'os.DateTimeStart'
										--when cf.ConstructorFilterId = 2 then 'os.TimeStart'
										when cf.ConstructorFilterId = 3 then 'os.IdOperator'
										when cf.ConstructorFilterId = 4 then 'os.IdTask'
										when cf.ConstructorFilterId = 5 then 't.IdProject'
										when cf.ConstructorFilterId = 7 then 'os.IsOutput'
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterOperationId = 0 then
											case
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'between'
												when cf.ConstructorFilterId = 1 and (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'between'
												when cf.ConstructorFilterId = 6 then 'between'
												--when cf.ConstructorFilterId = 2 then 'between'
												else '='
											end
									end
									
									+ ' ' +
									
									case
										when cf.ConstructorFilterId = 1 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'today' then 'cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisweek' then 'datepart(wk, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thismonth' then 'datepart(m, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisquarter' then 'datepart(q, getdate()) and datepart(yy, os.DateStart) = datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'thisyear' then 'datepart(yy, getdate())'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last7days' then 'dateadd(day, -7+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last30days' then 'dateadd(day, -30+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last90days' then 'dateadd(day, -90+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'last365days' then 'dateadd(day, -365+1, cast(floor(cast(getdate() as float)) as datetime)) and cast(floor(cast(getdate() as float)) as datetime)'
												-- различные варианты значений дат (сегодня, на этой неделе, в этом месяце, за последние 30 дней, в этом году ...)
												else ''
											end
										when cf.ConstructorFilterId = 6 then 'cast(''' + case when isnull(cf.ConstructorFilterValue1, '') = '' then '1900-01-01' else cf.ConstructorFilterValue1 end + ' ' + '00:00:00.000' + ''' as datetime) and ' + case when isnull(cf.ConstructorFilterValue2, '') = '' then 'getdate()' else 'cast(''' + cf.ConstructorFilterValue2 + ' ' + '23:59:59.900''' + ' as datetime)' end
										--when cf.ConstructorFilterId = 2 then 'cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000' + ''' as datetime) and cast(''' + '1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000' + ''' as datetime)'
										when cf.ConstructorFilterId = 3 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 4 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 5 then '''' + cast(cf.ConstructorFilterValueId as nvarchar(50)) + ''''
										when cf.ConstructorFilterId = 7 then
											case
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'incomingcalls' then '0'
												when (select Value from [dbo].[WO_Dashboards_Widgets_Designer_Filter_Value] where IdUniqueidentifier = cf.ConstructorFilterValueId) = 'outgoingcalls' then '1'
											end
									end
									
									+ ' and '
							from
							(
								select	ConstructorFilterId,
										ConstructorFilterOperationId,
										ConstructorFilterValueId,
										ConstructorFilterValue1,
										ConstructorFilterValue2
								from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
								where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
							) cf
							where	cf.ConstructorFilterId != 2
							
							--select @constructorfilters011
							
							-- шаблон для подсчета значения
							select	distinct
									@sqldesigner011 = dwdv.ModelQuery
							from	[dbo].[WO_Dashboards_Widgets_Constructor_Fields] dwcf
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Value] dwdv on dwcf.ConstructorValueId = dwdv.Id
							where	dwcf.IdConstructorFields = (select IdConstructorFields from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
									and dwcf.ConstructorValueId = 11
							
							--select @sqldesigner011
							
							-- добавляем отдельно фильтр по времени в шаблон
							if	(
									(
										select	count(*)
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
									) = 0
								)
								begin
									select @sqldesigner011 = replace(@sqldesigner011, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
								end
							else
								if	(
										(
											select	count(*)
											from
											(
												select	ConstructorFilterId,
														ConstructorFilterOperationId,
														ConstructorFilterValueId,
														ConstructorFilterValue1,
														ConstructorFilterValue2
												from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
												where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
											) cf
											where	cf.ConstructorFilterId = 2
										) = 0
									)
									begin
										select @sqldesigner011 = replace(@sqldesigner011, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01 00:00:00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01 23:59:59.900''')
									end
								else
									begin
										select @sqldesigner011 = replace(@sqldesigner011, '_tm_', 'declare @tm1 datetime set @tm1 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue1 + ':00.000'' declare @tm2 datetime set @tm2 = ''1900-01-01' + ' ' + cf.ConstructorFilterValue2 + ':00.000''')
										from
										(
											select	ConstructorFilterId,
													ConstructorFilterOperationId,
													ConstructorFilterValueId,
													ConstructorFilterValue1,
													ConstructorFilterValue2
											from	[dbo].[WO_Dashboards_Widgets_Constructor_Filters]
											where	IdConstructorFilters = (select IdConstructorFilters from [dbo].[WO_Dashboards_Widgets] where Id = @widgetidp)
										) cf
										where	cf.ConstructorFilterId = 2
									end
							
							--select @sqldesigner011
							
							-- в зависимости от фильтров добавляем их
							set @sqldesigner011 =
								case
									when @constructorfilters011 = 'and ' then replace(@sqldesigner011, '_where_', '')
									else replace(@sqldesigner011, '_where_', ' ' + (left(@constructorfilters011, len(@constructorfilters011)-len(' and '))))
								end
							
							--select @sqldesigner011
							--exec(@sqldesigner011 + ' select distinct * from #temp11 order by IdOperator, DateTimeBegin drop table #temp11 ')
							
							-- в зависимости от оси добавляем столбец
							declare	@constructoraxis011 nvarchar(4000)
							set	@constructoraxis011 = ''
							select distinct	@constructoraxis011 = @constructoraxis011 +
								case w.IdConstructorAxis
									when 1 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 287.999999999999) / 287.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 2 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 95.999999999999) / 95.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 3 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 47.999999999999) / 47.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 4 then 'convert(nvarchar(5), cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime), 108) + '' - '' + convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(dateadd(millisecond, 2, n.n) as float) * 23.999999999999) / 23.999999999999 - floor(cast(n.n as float))) as datetime)), 108) ' + da.Axis
									when 5 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float)) as datetime), 10) ' + da.Axis
									when 6 then 'cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime), 10) + '' - '' + cast(datepart(yy, cast(floor(cast(DateTimeBegin as float)) as datetime)) as nvarchar(4)) + ''-'' + convert(nvarchar(5), dateadd(dd, 6, cast(floor(cast(DateTimeBegin as float) - datepart(dw, DateTimeBegin) + 1) as datetime)), 10) ' + da.Axis
    								when 7 then '
      												case datepart(mm, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime))
      													when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-01''
      													when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-02''
      													when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-03''
      													when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-04''
      													when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-05''
      													when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-06''
      													when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-07''
      													when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-08''
      													when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-09''
      													when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-10''
      													when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-11''
      													when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-'' + cast(datepart(mm, DateTimeBegin) as nvarchar (2)) + ''-01'' as datetime)) as nvarchar(4)) + ''-12''
      												end ' + da.Axis
    								when 8 then 'cast(datepart(yy, cast(cast(datepart(yy, DateTimeBegin) as nvarchar (4)) + ''-01-01'' as datetime)) as nvarchar(4)) ' + da.Axis
    								when 9 then 'IdOperator '
    								when 10 then 'IdTask '
    								when 11 then 'IdProject '
    								
    								when 12 then '
    												case datepart(dw, DateTimeBegin)
      													when 1 then ''1''
      													when 2 then ''2''
      													when 3 then ''3''
      													when 4 then ''4''
      													when 5 then ''5''
      													when 6 then ''6''
      													when 7 then ''7''
      												end ' + da.Axis
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							--select @constructoraxis011
							
							-- в зависимости от оси добавляем параметр, служащий для вычисления интервалов времени
							declare	@constructoraxisn011 nvarchar(4000)
							set	@constructoraxisn011 = 'declare @ni int set @ni = '
							select distinct	@constructoraxisn011 = @constructoraxisn011 +
								case w.IdConstructorAxis
									when 1 then '5'
									when 2 then '15'
									when 3 then '30'
									when 4 then '60'
									else '1440'
    							end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
										 inner join [dbo].[WO_Dashboards_Widgets_Constructor_Fields] cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							--select @constructoraxisn011
							
							-- в зависимости от значений вычисляем их
							declare	@sqldesigner0111 nvarchar(4000)
							select @sqldesigner0111 =
								case w.IdConstructorAxis
									when 9 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues0111, len(@constructorvalues0111)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP11 from ('
									when 10 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues0111, len(@constructorvalues0111)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP11 from ('
									when 11 then 'select isnull(os.' + da.Axis + ', '''') ' + da.Axis + ', ' + (left(@constructorvalues0111, len(@constructorvalues0111)-len(', '))) + ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP11 from ('
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							declare	@sqldesigner0112 nvarchar(4000)
							select @sqldesigner0112 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name ' + da.Axis
									when 10 then 'os.IdTask, t.Name ' + da.Axis
									when 11 then 'os.IdProject, p.Name ' + da.Axis
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							declare	@sqldesigner0113 nvarchar(4000)
							select @sqldesigner0113 = (left(@constructorvalues011, len(@constructorvalues011)-len(', ')))
							
							declare	@sqldesigner0114_ nvarchar(4000)
							select @sqldesigner0114_ =
								case w.IdConstructorAxis
									when 9 then ''
									when 10 then ''
									when 11 then ''
									else ' into ##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP11'
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							declare	@sqldesigner0114_1 nvarchar(4000)
							select @sqldesigner0114_1 =
							'
							select distinct n.State, n.DateTimeBegin, n.DateTimeEnd,
							cast(cast(
							(
								case when (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) > dateadd(mi, @ni, n.n) then dateadd(mi, @ni, n.n) else (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) end
									-
								case when (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) > n.n then (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime)) else n.n end
							)
							as float) * 86400 as int) LenTimeInterval,
							'
							
							declare	@sqldesigner0114_2 nvarchar(4000)
							select @sqldesigner0114_2 =
							'
							from
							(
								select t.*, dateadd(mi, n.n*@ni, @tm1) n from
								(
									select a1.n * 100 + a2.n * 10 + a3.n n from
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a1
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a2
										cross join
									(select 0 as n union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as a3
								) n
								cross join #temp11 t
								where dateadd(mi, n.n*@ni, @tm1) between @tm1 and @tm2
							) n
							where n.n <= (n.DateTimeEnd - cast(floor(cast(n.DateTimeEnd as float)) as datetime)) and dateadd(mi, @ni, n.n) >= (n.DateTimeBegin - cast(floor(cast(n.DateTimeBegin as float)) as datetime))
							'
							
							declare	@sqldesigner0114 nvarchar(4000)
							select @sqldesigner0114 =
								case w.IdConstructorAxis
									when 9 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi on os.IdOperator = oi.Id '
									when 10 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] t on os.IdTask = t.Id '
									when 11 then 'left join [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] p on os.IdProject = p.Id '
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							declare	@sqldesigner0115 nvarchar(4000)
							select @sqldesigner0115 =
								case w.IdConstructorAxis
									when 1 then 'os.' + da.Axis
									when 2 then 'os.' + da.Axis
									when 3 then 'os.' + da.Axis
									when 4 then 'os.' + da.Axis
									when 5 then 'os.' + da.Axis
									when 6 then 'os.' + da.Axis
									when 7 then 'os.' + da.Axis
									when 8 then 'os.' + da.Axis
									when 9 then 'os.IdOperator, oi.Name'
									when 10 then 'os.IdTask, t.Name'
									when 11 then 'os.IdProject, p.Name'
									when 12 then 'os.' + da.Axis
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							declare	@sqldesigner0116 nvarchar(4000)
							select @sqldesigner0116 =
								case w.IdConstructorAxis
									when 1 then ' order by os.' + da.Axis + ' asc'
									when 2 then ' order by os.' + da.Axis + ' asc'
									when 3 then ' order by os.' + da.Axis + ' asc'
									when 4 then ' order by os.' + da.Axis + ' asc'
									when 5 then ' order by os.' + da.Axis + ' asc'
									when 6 then ' order by os.' + da.Axis + ' asc'
									when 7 then ' order by os.' + da.Axis + ' asc'
									when 8 then ' order by os.' + da.Axis + ' asc'
									when 12 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							declare	@sqldesigner0117 nvarchar(4000)
							select @sqldesigner0117 =
								case w.IdConstructorAxis
									when 9 then ') os'
									when 10 then ') os'
									when 11 then ') os'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							declare	@sqldesigner0118 nvarchar(4000)
							select @sqldesigner0118 =
								case w.IdConstructorAxis
									when 9 then ' order by os.' + da.Axis + ' asc'
									when 10 then ' order by os.' + da.Axis + ' asc'
									when 11 then ' order by os.' + da.Axis + ' asc'
									else ''
								end
							from	[dbo].[WO_Dashboards_Widgets] w
										inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
											inner join (select distinct IdConstructorFields, ConstructorValueId from [oktell_settings].[dbo].[WO_Dashboards_Widgets_Constructor_Fields]) cf on w.IdConstructorFields = cf.IdConstructorFields
							where	w.Id = @widgetidp
									and cf.ConstructorValueId = 11
							
							
							--select @sqldesigner011 union all select ' ' union all select @constructoraxisn011 union all select ' ' union all select @sqldesigner0111 union all select 'select ' union all select @sqldesigner0112 union all select ', ' union all select @sqldesigner0113 union all select @sqldesigner0114_ union all select ' from (' + @sqldesigner0114_1 union all select @constructoraxis011 union all select @sqldesigner0114_2 union all select ') os ' union all select @sqldesigner0114 union all select 'group by ' union all select @sqldesigner0115 union all select @sqldesigner0116 union all select @sqldesigner0117 union all select @sqldesigner0118 union all select ' drop table #temp11 '
							exec('SET DATEFORMAT ymd ' + @sqldesigner011 + ' ' + @constructoraxisn011 + ' ' + @sqldesigner0111 + 'select ' + @sqldesigner0112 + ', ' + @sqldesigner0113 + @sqldesigner0114_ + ' from (' + @sqldesigner0114_1 + @constructoraxis011 + @sqldesigner0114_2 + ') os ' + @sqldesigner0114 + 'group by ' + @sqldesigner0115 + @sqldesigner0116 + @sqldesigner0117 + @sqldesigner0118 + ' drop table #temp11 ')
														
						end
					
					
					
					
					
					declare @axis nvarchar(50)
					select	@axis = da.Axis
					from	[dbo].[WO_Dashboards_Widgets] w
								inner join [dbo].[WO_Dashboards_Widgets_Designer_Axis] da on w.IdConstructorAxis = da.Id
					where	w.Id = @widgetidp
					
					--select @axis
					
					
					
					declare @axistable nvarchar(4000)
					set @axistable = ''
					select	@axistable = @axistable +
							'select ' + @axis + ' from ' + name + ' union '
					from	tempdb.sys.tables where name like '##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP%'
					
					select	@axistable = 'declare @axis table (' + @axis + ' nvarchar(1000) collate database_default) insert into @axis ' + left(@axistable, len(@axistable)-len(' union ')) + ' order by ' + @axis + ' asc'
					
					
					
					declare	@selecttables nvarchar(4000)
					set	@selecttables = ''
					select	@selecttables = @selecttables +
							+ ' left join ' +
							name
							+ ' ' +
							right(name, len(name)-62)
							+ ' on a.' + @axis + ' = ' + right(name, len(name)-62) + '.' + @axis
					from	tempdb.sys.tables where name like '##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP%'
					
					--select @selecttables
					
					
					
					declare @valuestable nvarchar(4000)
					set @valuestable = ''
					select	@valuestable = @valuestable +
							+ 'isnull(' +
							right(t.name, len(t.name)-62) + '.[' + tc.name + '], 0) ' + '[' + tc.name + ']' + ', '
					from	tempdb.sys.tables t inner join tempdb.sys.syscolumns tc on t.object_id = tc.id
					where	t.name like '##DashboardsWidgetsConstructor' + @widgetidn + 'TEMP%'
							and tc.name != @axis
					
					select	@valuestable = left(@valuestable, len(@valuestable)-len(', '))
					
					--select @valuestable
					
					
					exec(@axistable + ' select a.' + @axis + ', ' + @valuestable + ' from @axis a' + @selecttables)
					
					
					
				end
			
			
			-- таблица бд
			if ((select w.[Source] from [dbo].[WO_Dashboards_Widgets] w where w.Id = @widgetidp) = 1)
				begin
					--select	'таблица бд'
					
					declare	@sqltable nvarchar(4000)
					
					
					declare	@fields nvarchar(4000)
					set	@fields = ''
					select	@fields = @fields + wf.Name + ', '
					from	[dbo].[WO_Dashboards_Widgets] w 
								inner join [dbo].[WO_Dashboards_Widgets_Fields] wf on w.IdFields = wf.IdFields
					where	w.Id = @widgetidp
					
					declare	@filters nvarchar(4000)
					set	@filters = ''
					select	@filters = @filters + w.OperationTextValue + ' and ' from
					(
						select	wf.Name +
								' ' +
								case
									when wfo.Id in (4,5,6,7) then replace(wfo.OperationText, '_', wf.Value)
									else wfo.OperationText + ' ''' + wf.Value + ''''
								end OperationTextValue
						from	[dbo].[WO_Dashboards_Widgets] w
									inner join [dbo].[WO_Dashboards_Widgets_Filters] wf on w.IdFilters = wf.IdFilters
									inner join [dbo].[WO_Dashboards_Widgets_Filters_Operation] wfo on wf.Operation = wfo.Id
						where	w.Id = @widgetidp
					) w
					
					
					
					set	@sqltable =
						case
							when ( select count(*) 
								   from [dbo].[WO_Dashboards_Widgets] w 
										inner join [dbo].[WO_Dashboards_Widgets_Fields] wf on w.IdFields = wf.IdFields 
								   where w.Id = @widgetidp and wf.Name is not null and wf.Value is not null) = 0 
								then 'select null'
							else
								'select ' +
									case 
										when (( select count(*) 
												from [dbo].[WO_Dashboards_Widgets] w 
												where (w.Id = @widgetidp) 
													and (w.Type = 4) 
													and (w.ShowTopRows is not null)) != 0 ) 
											then 'top(' + cast((select w.ShowTopRows from [dbo].[WO_Dashboards_Widgets] w where w.Id = @widgetidp) as varchar) + ') '
										else ''
									end +
								(left(@fields, len(@fields)-len(', '))) +
								' from ' +
								(
									select	w.NameTable
									from	[dbo].[WO_Dashboards_Widgets] w
									where	w.Id = @widgetidp
								) +
								case
									when (( select count(*) 
										   from [dbo].[WO_Dashboards_Widgets] w 
												inner join [dbo].[WO_Dashboards_Widgets_Filters] wf on w.IdFilters = wf.IdFilters 
										   where (w.Id = @widgetidp) and (wf.Name is not null) and (wf.Operation is not null)) = 0 ) 
										then ''
									else
										' where ' + (left(@filters, len(@filters)-len(' and ')))
								end +
								case
									when (( select count(*) 
											from [dbo].[WO_Dashboards_Widgets] w 
											where (w.Id = @widgetidp) and (w.Type = 4) and (w.OrderBy is not null) and (w.OrderBy != '')) != 0 ) 
										then ' order by ' + (select w.OrderBy from [dbo].[WO_Dashboards_Widgets] w where w.Id = @widgetidp)
									else ''
								end
						end
					
								
					exec(@sqltable)
				end
			
			
			-- sql-запрос
			if ((select w.[Source] from [dbo].[WO_Dashboards_Widgets] w where w.Id = @widgetidp) = 2)
				begin
					
					--select	'sql-запрос'
					
					declare	@sqlquery1 nvarchar(4000)
					declare	@sqlquery2 nvarchar(4000)
					declare	@sqlquery3 nvarchar(4000)
					declare	@sqlquery4 nvarchar(4000)
					declare	@sqlquery5 nvarchar(4000)
					declare	@sqlquery6 nvarchar(4000)
					declare	@sqlquery7 nvarchar(4000)
					declare	@sqlquery8 nvarchar(4000)
					declare	@sqlquery9 nvarchar(4000)
					declare	@sqlquery10 nvarchar(4000)
					
					
					set	@sqlquery1 =
					(
						select	substring(w.Query, 1, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery2 =
					(
						select	substring(w.Query, 4001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery3 =
					(
						select	substring(w.Query, 8001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery4 =
					(
						select	substring(w.Query, 12001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery5 =
					(
						select	substring(w.Query, 16001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery6 =
					(
						select	substring(w.Query, 20001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery7 =
					(
						select	substring(w.Query, 24001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery8 =
					(
						select	substring(w.Query, 28001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery9 =
					(
						select	substring(w.Query, 32001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					set	@sqlquery10 =
					(
						select	substring(w.Query, 36001, 4000)
						from	[dbo].[WO_Dashboards_Widgets] w
						where	w.Id = @widgetidp
					)
					
					
					exec(@sqlquery1 + @sqlquery2 + @sqlquery3 + @sqlquery4 + @sqlquery5 + @sqlquery6 + @sqlquery7 + @sqlquery8 + @sqlquery9 + @sqlquery10)
					
				end
				
				
				
		end
	
end
GO